local RUF = LibStub("AceAddon-3.0"):GetAddon("RUF")
local L = LibStub("AceLocale-3.0"):GetLocale("RUF")
local LSM = LibStub("LibSharedMedia-3.0")
local _, ns = ...
local oUF = ns.oUF
_, PlayerClass = UnitClass('player')
local ClassPowerID, ClassPowerType, ClassPowerCharges, RequireSpec, RequireSpell, ClassVisibility

local DefaultOptions = RUF_cfg
local cfg

function RUF:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("RUFDB", DefaultOptions, true) -- Setup Saved Variables
	--self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	--self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	--self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
	local LibDualSpec = LibStub('LibDualSpec-1.0')
	LibDualSpec:EnhanceDatabase(self.db, "RUF")
	cfg = self.db.profile
	
		-- Register /RUF command
	self:RegisterChatCommand("RUF", "ChatCommand")
end

do -- Register Class Bar Variable Values
	if(PlayerClass == 'MONK') then
		ClassPowerID = 12
		ClassPowerType = "CHI"
		RequireSpec = SPEC_MONK_WINDWALKER
	elseif(PlayerClass == 'PALADIN') then
		ClassPowerID = 9
		ClassPowerType = "HOLY_POWER"
		RequireSpec = SPEC_PALADIN_RETRIBUTION
	elseif(PlayerClass == 'WARLOCK') then
		ClassPowerID = 7
		ClassPowerType = "SOUL_SHARDS"
	elseif(PlayerClass == 'ROGUE' or PlayerClass == 'DRUID') then
		ClassPowerID = 4
		ClassPowerType = 'COMBO_POINTS'
		if(PlayerClass == 'DRUID') then
			RequireSpell = 5221 -- Shred
		end
	elseif(PlayerClass == 'MAGE') then
		ClassPowerID = 16
		ClassPowerType = 'ARCANE_CHARGES'
		RequireSpec = SPEC_MAGE_ARCANE
	elseif(PlayerClass == 'DEATHKNIGHT') then
		ClassPowerID = 5
		ClassPowerType = 'RUNES'
	end
end

local function colorsAndPercent(a, b, ...)
	if(a <= 0 or b == 0) then
		return nil, ...
	elseif(a >= b) then
		return nil, select(select('#', ...) - 2, ...)
	end

	local num = select('#', ...) / 3
	local segment, relperc = math.modf((a / b) * (num - 1))
	return relperc, select((segment * 3) + 1, ...)
end

local function ColorGradient(...)
	local relperc, r1, g1, b1, r2, g2, b2 = colorsAndPercent(...)
	if(relperc) then
		return r1 + (r2 - r1) * relperc, g1 + (g2 - g1) * relperc, b1 + (b2 - b1) * relperc
	else
		return r1, g1, b1
	end
end

local function HealthPostUpdate(element, unit, cur, min, max)
	element.__owner.Health.colorTapping = RUF.db.profile.Colors.Health.colorTapping
	element.__owner.Health.colorDisconnected = RUF.db.profile.Colors.Health.colorDisconnected
	element.__owner.Health.colorClass = RUF.db.profile.Colors.Health.colorClass
	element.__owner.Health.colorReaction = RUF.db.profile.Colors.Health.colorReaction
	element.__owner.Health.colorSmooth = RUF.db.profile.Colors.Health.colorSmooth
	element.__owner.Health.smoothGradient = RUF.db.profile.Colors.Health.BarGradient
	element.__owner.Health.colorHealth = RUF.db.profile.Colors.Health.colorHealth
	element.__owner.colors.health = RUF.db.profile.Colors.Health.HealthColor
	element.__owner.Health.Smooth = RUF.db.profile.Colors.Health.Smooth -- Smoothly Animate

	--local pType = select(1,UnitPowerType(unit))
	--local pr,pg,pb = unpack(RUF.db.profile.Colors.PowerColors[pType])
	--local statusBarTexture = LSM:Fetch("statusbar", RUF.db.profile.Texture.Power)
	--element.__owner.Power:SetStatusBarTexture(statusBarTexture)
	--element.__owner.Power.bg:SetColorTexture(pr*0.35,pg*0.35,pb*0.35,0.5)

	for i = 1,8 do
		element.__owner.colors.reaction[i][1] = RUF.db.profile.Colors.ReactionColors[i][1]
		element.__owner.colors.reaction[i][2] = RUF.db.profile.Colors.ReactionColors[i][2]
		element.__owner.colors.reaction[i][3] = RUF.db.profile.Colors.ReactionColors[i][3]
	end
end

local function SetHealth(self, unit)
	-- Health Bar
	local Health = CreateFrame('StatusBar', nil, self)
	local statusBarTexture = LSM:Fetch("statusbar", RUF.db.profile.Texture.Health)
	Health:SetStatusBarTexture(statusBarTexture)

	 -- Priority: Tapping, Disconnected, Class, ClassNPC, ClassPet, Reaction, Smooth, Health
	 -- Color Settings
	Health.colorTapping = RUF.db.profile.Colors.Health.colorTapping
	Health.colorDisconnected = RUF.db.profile.Colors.Health.colorDisconnected
	Health.colorClass = RUF.db.profile.Colors.Health.colorClass
	--Health.colorClassNPC = RUF.db.profile.Colors.Health.colorClassNPC -- No ingame option.
	--Health.colorClassPet = RUF.db.profile.Colors.Health.colorClassPet -- No ingame option.
	Health.colorReaction = RUF.db.profile.Colors.Health.colorReaction
	Health.colorSmooth = RUF.db.profile.Colors.Health.colorSmooth
	Health.smoothGradient = RUF.db.profile.Colors.Health.BarGradient
	Health.colorHealth = RUF.db.profile.Colors.Health.colorHealth	
	Health.Smooth = RUF.db.profile.Colors.Health.Smooth -- Smoothly Animate
	Health:SetHeight(RUF.db.profile.unit[unit].Height-2)
	if RUF.db.profile.unit[unit].Bars.ReverseFill == true then
		Health:SetFillStyle("REVERSE")
	else
		Health:SetFillStyle("STANDARD")

	end
    Health:SetPoint('TOP',0,-1)
    Health:SetPoint('LEFT',1,0)
	Health:SetPoint('RIGHT',-1,0)
	Health:SetFrameLevel(1)
	
	-- Health Background
	-- Solid 75% Opacity.
    local HealthBG = Health:CreateTexture(nil, 'BACKGROUND')
	HealthBG:SetHeight((RUF.db.profile.unit[unit].Height - RUF.db.profile.unit[unit].PowerHeight) - 2)
    HealthBG:SetPoint('TOP',0,0)
    HealthBG:SetPoint('LEFT',0,0)
	HealthBG:SetPoint('RIGHT',0,0)
	HealthBG:SetPoint("BOTTOM",0,RUF.db.profile.unit[unit].PowerHeight)
	HealthBG:SetTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.HealthBG)) -- TODO Stop ColorSmooth applying to BG when it has a colour - try, createframe instead of create texture
	HealthBG.colorSmooth = false
	HealthBG:SetColorTexture(0, 0, 0, 0.75)
	Health.bg = HealthBG
	self.Health = Health
end	

local function PowerPostUpdate(element, unit, cur, min, max)
	if not unit then return end

	-- ERROR WITH VEHICLES. TRY IF UNIT == VEHICLE or something like that.
	if RUF.db.profile.unit[unit].Bars.Power == 0 and element.__owner.Power:IsShown() then -- Always Hidden on this unit.
		element.__owner.Power:Hide()
		element.__owner.Power.bg:Hide()

		-- Move Healthbar BG down so there is no background overlap
		element.__owner.Health.bg:SetPoint('BOTTOM',0,0)
	elseif RUF.db.profile.unit[unit].Bars.Power == 1 then -- Hidden at 0
		if cur < 1 and element.__owner.Power:IsShown() then
			element.__owner.Power:Hide()
			element.__owner.Power.bg:Hide()
			element.__owner.Health.bg:SetPoint('BOTTOM',0,0)
		end
		if cur > 0 and not element.__owner.Power:IsShown() then 
			element.__owner.Power:Show()
			element.__owner.Power.bg:Show()
			element.__owner.Health.bg:SetPoint('BOTTOM',0,RUF.db.profile.unit[unit].PowerHeight)
		end
	elseif 	RUF.db.profile.unit[unit].Bars.Power == 2 and not element.__owner.Power:IsShown() then		
		element.__owner.Power:Show()
		element.__owner.Power.bg:Show()
		element.__owner.Health.bg:SetPoint('BOTTOM',0,RUF.db.profile.unit[unit].PowerHeight)
	end

	if RUF.db.profile.unit[unit].Texts.Power == 2 then
		element.__owner.PowerTextParent:Show()
	elseif RUF.db.profile.unit[unit].Texts.Power == 1 and UnitPower(unit) > 0 then
		element.__owner.PowerTextParent:Show()
	else
		element.__owner.PowerTextParent:Hide()
	end

	local pType = select(1,UnitPowerType(unit))
	local class = select(2,UnitClass(unit))
	if not class then class = "PRIEST" end
	--local r,g,b = unpack(RUF.db.profile.Colors.PowerColors[pType])
	local r,g,b = unpack(RUF.db.profile.Colors.Power.PowerColor)
	if RUF.db.profile.Colors.Power.colorTapping and element.tapped then
		r,g,b = unpack(RUF.db.profile.Colors.MiscColors.Tapping)
	elseif RUF.db.profile.Colors.Power.colorDisconnected and element.disconnected then
		r,g,b = unpack(RUF.db.profile.Colors.MiscColors.Disconnected)
	elseif RUF.db.profile.Colors.Power.colorClass and UnitIsPlayer(unit) then
		r,g,b = unpack(RUF.db.profile.Colors.ClassColors[class])
	elseif RUF.db.profile.Colors.Power.colorPower then
		r,g,b = unpack(RUF.db.profile.Colors.PowerColors[pType])
	elseif RUF.db.profile.Colors.Power.colorReaction then
		if UnitPlayerControlled(unit) and not UnitCanAttack("target","player") and not UnitIsPlayer(unit) then  -- If the unit is an allied pet then show as blue.
			r,g,b = unpack(RUF.db.profile.Colors.ReactionColors[10])
		elseif UnitReaction(unit,'player') then -- If the unit is an offline party member, possibly others too?
			r,g,b = unpack(RUF.db.profile.Colors.ReactionColors[UnitReaction(unit, 'player')])
		elseif UnitInParty(unit) then
			r,g,b = unpack(RUF.db.profile.Colors.ReactionColors[5]) -- So Reaction Works when Party member is in a different zone and UnitReaction returns nil
		else
			r,g,b = unpack(RUF.db.profile.Colors.Power.PowerColor)
		end
	elseif RUF.db.profile.Colors.Power.colorSmooth then
		local cur, max = UnitPower(unit), UnitPowerMax(unit)
		r,g,b = ColorGradient(cur, max, unpack(RUF.db.profile.Colors.Power.BarGradient))				
	else
		r,g,b = unpack(RUF.db.profile.Colors.Power.PowerColor)
	end

	do 
		element.__owner.Power.colorTapping = RUF.db.profile.Colors.Power.colorTapping
		element.__owner.Power.colorDisconnected = RUF.db.profile.Colors.Power.colorDisconnected
		element.__owner.Power.colorClass = RUF.db.profile.Colors.Power.colorClass
		element.__owner.Power.colorReaction = RUF.db.profile.Colors.Power.colorReaction
		element.__owner.Power.colorSmooth = RUF.db.profile.Colors.Power.colorSmooth
		element.__owner.Power.smoothGradient = RUF.db.profile.Colors.Power.BarGradient
		element.__owner.Power.colorPower = RUF.db.profile.Colors.Power.colorPower
		element.__owner.Power.Smooth = RUF.db.profile.Colors.Power.Smooth -- Smoothly Animate
		for i = 1,8 do
			element.__owner.colors.reaction[i][1] = RUF.db.profile.Colors.ReactionColors[i][1]
			element.__owner.colors.reaction[i][2] = RUF.db.profile.Colors.ReactionColors[i][2]
			element.__owner.colors.reaction[i][3] = RUF.db.profile.Colors.ReactionColors[i][3]
		end
		element.__owner.colors.power.MANA = RUF.db.profile.Colors.PowerColors[0]
		element.__owner.colors.power.RAGE = RUF.db.profile.Colors.PowerColors[1]
		element.__owner.colors.power.FOCUS = RUF.db.profile.Colors.PowerColors[2]
		element.__owner.colors.power.ENERGY = RUF.db.profile.Colors.PowerColors[3]
		element.__owner.colors.power.COMBO_POINTS = RUF.db.profile.Colors.PowerColors[4]
		element.__owner.colors.power.RUNES = RUF.db.profile.Colors.PowerColors[5]
		element.__owner.colors.power.RUNIC_POWER = RUF.db.profile.Colors.PowerColors[6]
		element.__owner.colors.power.SOUL_SHARDS = RUF.db.profile.Colors.PowerColors[7]
		element.__owner.colors.power.LUNAR_POWER = RUF.db.profile.Colors.PowerColors[8]
		element.__owner.colors.power.HOLY_POWER = RUF.db.profile.Colors.PowerColors[9]
		element.__owner.colors.power.MAELSTROM = RUF.db.profile.Colors.PowerColors[11]
		element.__owner.colors.power.CHI = RUF.db.profile.Colors.PowerColors[12]
		element.__owner.colors.power.INSANITY = RUF.db.profile.Colors.PowerColors[13]
		element.__owner.colors.power.ARCANE_CHARGES = RUF.db.profile.Colors.PowerColors[16]
		element.__owner.colors.power.FURY = RUF.db.profile.Colors.PowerColors[17]
		element.__owner.colors.power.PAIN = RUF.db.profile.Colors.PowerColors[18]
	end

	local statusBarTexture = LSM:Fetch("statusbar", RUF.db.profile.Texture.Power)
	element.__owner.Power:SetStatusBarTexture(statusBarTexture)
	element.__owner.Power:SetStatusBarColor(r,g,b)
	element.__owner.Power.bg:SetVertexColor(r,g,b,1)
end	
	
local function SetPower(self, unit)
	-- Power Bar
	local Power = CreateFrame('StatusBar', nil, self)
	local statusBarTexture = LSM:Fetch("statusbar", RUF.db.profile.Texture.Power)
	Power:SetStatusBarTexture(statusBarTexture)

	-- Priority: Tapping, Disconnected, Class, ClassNPC, ClassPet, Reaction, Smooth, Power
	-- Color Settings
	Power.colorTapping = RUF.db.profile.Colors.Power.colorTapping
	Power.colorDisconnected = RUF.db.profile.Colors.Power.colorDisconnected
	Power.colorClass = RUF.db.profile.Colors.Power.colorClass
	Power.colorReaction = RUF.db.profile.Colors.Power.colorReaction
	Power.colorSmooth = RUF.db.profile.Colors.Power.colorSmooth
	Power.smoothGradient = RUF.db.profile.Colors.Power.BarGradient
	Power.colorPower = RUF.db.profile.Colors.Power.colorPower	
	Power.Smooth = RUF.db.profile.Colors.Power.Smooth -- Smoothly Animate
	if RUF.db.profile.unit[unit].Bars.ReverseFill == true then
		Power:SetFillStyle("REVERSE")
	else
		Power:SetFillStyle("STANDARD")
	end
	Power:SetHeight(RUF.db.profile.unit[unit].PowerHeight)
	Power:SetPoint('BOTTOM',0,1)
	Power:SetPoint('LEFT',1,0)
	Power:SetPoint('RIGHT',-1,0)
	Power:SetFrameLevel(5)
	
	-- Power Background
	-- Solid 75% Opacity.
    local PowerBG = Power:CreateTexture(nil, 'BACKGROUND')
	PowerBG:SetAllPoints(Power)
	local pType = select(1,UnitPowerType(unit))
	local r,g,b = unpack(RUF.db.profile.Colors.Power.PowerColor)
	PowerBG:SetTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.PowerBG))
	PowerBG:SetColorTexture(r*0.35,g*0.35,b*0.35,0.75) -- 35% Brightness for the Background.
	PowerBG.colorSmooth = false
	Power.bg = PowerBG
	self.Power = Power
end

local function AdditionalPowerPostUpdate(element, unit, cur, min, max)
	if not unit then return end
	local _, unitClass = UnitClass(unit)
	local powerType = UnitPowerType(unit)
	local shouldEnable = false
	--if unitClass == "DRUID" then
		--if powerType ~= "MANA" then
		--	shouldEnable = true
		--end
	if UnitPowerMax(unit, ADDITIONAL_POWER_BAR_INDEX) ~= 0 then
		if(ALT_MANA_BAR_PAIR_DISPLAY_INFO[unitClass]) then
			shouldEnable = ALT_MANA_BAR_PAIR_DISPLAY_INFO[unitClass][powerType]
		end
	end
	if not shouldEnable then
		element.__owner.AdditionalPower:Hide()
		element.__owner.AdditionalPower.bg:Hide()


		element.__owner.Power:ClearAllPoints()
		element.__owner.Power:SetPoint('BOTTOM',0,1)
		element.__owner.Power:SetPoint('LEFT',1,0)
		element.__owner.Power:SetPoint('RIGHT',-1,0)
		return
	else
		element.__owner.AdditionalPower:Show()
		element.__owner.AdditionalPower.bg:Show()

		element.__owner.Power:ClearAllPoints()
		element.__owner.Power:SetPoint('TOP',0,-1)
		element.__owner.Power:SetPoint('LEFT',1,0)
		element.__owner.Power:SetPoint('RIGHT',-1,0)
	end

	--if(unit ~= 'player' or (powertype and powertype ~= ADDITIONAL_POWER_BAR_NAME)) then return end
	if RUF.db.profile.unit[unit].Bars.AdditionalPower == 0 and element.__owner.AdditionalPower:IsShown() then -- Always Hidden on this unit.
		element.__owner.AdditionalPower:Hide()
		element.__owner.AdditionalPower.bg:Hide()

		-- Move Healthbar BG down so there is no background overlap
		--element.__owner.Health.bg:SetPoint('BOTTOM',0,0)


		element.__owner.Power:ClearAllPoints()
		element.__owner.Power:SetPoint('BOTTOM',0,1)
		element.__owner.Power:SetPoint('LEFT',1,0)
		element.__owner.Power:SetPoint('RIGHT',-1,0)
	elseif RUF.db.profile.unit[unit].Bars.AdditionalPower == 1 then -- Hidden at 0
		if cur < 1 and element.__owner.AdditionalPower:IsShown() then
			element.__owner.AdditionalPower:Hide()
			element.__owner.AdditionalPower.bg:Hide()
			--element.__owner.Health.bg:SetPoint('BOTTOM',0,0)


			element.__owner.Power:ClearAllPoints()
			element.__owner.Power:SetPoint('BOTTOM',0,1)
			element.__owner.Power:SetPoint('LEFT',1,0)
			element.__owner.Power:SetPoint('RIGHT',-1,0)
		end
		if cur > 0 and not element.__owner.AdditionalPower:IsShown() then 
			element.__owner.AdditionalPower:Show()
			element.__owner.AdditionalPower.bg:Show()
			--element.__owner.Health.bg:SetPoint('BOTTOM',0,RUF.db.profile.unit[unit].AdditionalPowerHeight)


			element.__owner.Power:ClearAllPoints()
			element.__owner.Power:SetPoint('TOP',0,-1)
			element.__owner.Power:SetPoint('LEFT',1,0)
			element.__owner.Power:SetPoint('RIGHT',-1,0)
		end
	elseif 	RUF.db.profile.unit[unit].Bars.AdditionalPower == 2 and not element.__owner.AdditionalPower:IsShown() then		
		element.__owner.AdditionalPower:Show()
		element.__owner.AdditionalPower.bg:Show()
		--element.__owner.Health.bg:SetPoint('BOTTOM',0,RUF.db.profile.unit[unit].PowerHeight)


		element.__owner.Power:ClearAllPoints()
		element.__owner.Power:SetPoint('TOP',0,-1)
		element.__owner.Power:SetPoint('LEFT',1,0)
		element.__owner.Power:SetPoint('RIGHT',-1,0)
	end

	--[[if RUF.db.profile.unit[unit].Texts.Power == 2 then
		element.__owner.PowerTextParent:Show()
	elseif RUF.db.profile.unit[unit].Texts.Power == 1 and UnitPower(unit) > 0 then
		element.__owner.PowerTextParent:Show()
	else
		element.__owner.PowerTextParent:Hide()
	end]]--

	local pType = 0
	local class = select(2,UnitClass(unit))
	if not class then class = "PRIEST" end
	--local r,g,b = unpack(RUF.db.profile.Colors.PowerColors[pType])
	local r,g,b = unpack(RUF.db.profile.Colors.Power.PowerColor)
	if RUF.db.profile.Colors.Power.colorTapping and element.tapped then
		r,g,b = unpack(RUF.db.profile.Colors.MiscColors.Tapping)
	elseif RUF.db.profile.Colors.Power.colorDisconnected and element.disconnected then
		r,g,b = unpack(RUF.db.profile.Colors.MiscColors.Disconnected)
	elseif RUF.db.profile.Colors.Power.colorClass and UnitIsPlayer(unit) then
		r,g,b = unpack(RUF.db.profile.Colors.ClassColors[class])
	elseif RUF.db.profile.Colors.Power.colorPower then
		r,g,b = unpack(RUF.db.profile.Colors.PowerColors[pType])
	elseif RUF.db.profile.Colors.Power.colorReaction then
		if UnitPlayerControlled(unit) and not UnitCanAttack("target","player") and not UnitIsPlayer(unit) then  -- If the unit is an allied pet then show as blue.
			r,g,b = unpack(RUF.db.profile.Colors.ReactionColors[10])
		elseif UnitReaction(unit,'player') then -- If the unit is an offline party member, possibly others too?
			r,g,b = unpack(RUF.db.profile.Colors.ReactionColors[UnitReaction(unit, 'player')])
		elseif UnitInParty(unit) then
			r,g,b = unpack(RUF.db.profile.Colors.ReactionColors[5]) -- So Reaction Works when Party member is in a different zone and UnitReaction returns nil
		else
			r,g,b = unpack(RUF.db.profile.Colors.Power.PowerColor)
		end
	elseif RUF.db.profile.Colors.Power.colorSmooth then
		local cur, max = UnitPower(unit), UnitPowerMax(unit)
		r,g,b = ColorGradient(cur, max, unpack(RUF.db.profile.Colors.Power.BarGradient))				
	else
		r,g,b = unpack(RUF.db.profile.Colors.Power.PowerColor)
	end

	do
		element.__owner.Power.colorTapping = RUF.db.profile.Colors.Power.colorTapping
		element.__owner.Power.colorDisconnected = RUF.db.profile.Colors.Power.colorDisconnected
		element.__owner.Power.colorClass = RUF.db.profile.Colors.Power.colorClass
		element.__owner.Power.colorReaction = RUF.db.profile.Colors.Power.colorReaction
		element.__owner.Power.colorSmooth = RUF.db.profile.Colors.Power.colorSmooth
		element.__owner.Power.smoothGradient = RUF.db.profile.Colors.Power.BarGradient
		element.__owner.Power.colorPower = RUF.db.profile.Colors.Power.colorPower
		element.__owner.Power.Smooth = RUF.db.profile.Colors.Power.Smooth -- Smoothly Animate
		for i = 1,8 do
			element.__owner.colors.reaction[i][1] = RUF.db.profile.Colors.ReactionColors[i][1]
			element.__owner.colors.reaction[i][2] = RUF.db.profile.Colors.ReactionColors[i][2]
			element.__owner.colors.reaction[i][3] = RUF.db.profile.Colors.ReactionColors[i][3]
		end
		element.__owner.colors.power.MANA = RUF.db.profile.Colors.PowerColors[0]
		element.__owner.colors.power.RAGE = RUF.db.profile.Colors.PowerColors[1]
		element.__owner.colors.power.FOCUS = RUF.db.profile.Colors.PowerColors[2]
		element.__owner.colors.power.ENERGY = RUF.db.profile.Colors.PowerColors[3]
		element.__owner.colors.power.COMBO_POINTS = RUF.db.profile.Colors.PowerColors[4]
		element.__owner.colors.power.RUNES = RUF.db.profile.Colors.PowerColors[5]
		element.__owner.colors.power.RUNIC_POWER = RUF.db.profile.Colors.PowerColors[6]
		element.__owner.colors.power.SOUL_SHARDS = RUF.db.profile.Colors.PowerColors[7]
		element.__owner.colors.power.LUNAR_POWER = RUF.db.profile.Colors.PowerColors[8]
		element.__owner.colors.power.HOLY_POWER = RUF.db.profile.Colors.PowerColors[9]
		element.__owner.colors.power.MAELSTROM = RUF.db.profile.Colors.PowerColors[11]
		element.__owner.colors.power.CHI = RUF.db.profile.Colors.PowerColors[12]
		element.__owner.colors.power.INSANITY = RUF.db.profile.Colors.PowerColors[13]
		element.__owner.colors.power.ARCANE_CHARGES = RUF.db.profile.Colors.PowerColors[16]
		element.__owner.colors.power.FURY = RUF.db.profile.Colors.PowerColors[17]
		element.__owner.colors.power.PAIN = RUF.db.profile.Colors.PowerColors[18]
	end

	local statusBarTexture = LSM:Fetch("statusbar", RUF.db.profile.Texture.AdditionalPower)
	element.__owner.AdditionalPower:SetStatusBarTexture(statusBarTexture)
	element.__owner.AdditionalPower:SetStatusBarColor(r,g,b)
	element.__owner.AdditionalPower.bg:SetVertexColor(r,g,b,1)
end	

local function SetAdditionalPower(self, unit) -- Additional Power Bar e.g Mana in Cat Form
	local Power = CreateFrame('StatusBar', nil, self)
	local statusBarTexture = LSM:Fetch("statusbar", RUF.db.profile.Texture.AdditionalPower)
	Power:SetStatusBarTexture(statusBarTexture)

	-- Priority: Tapping, Disconnected, Class, ClassNPC, ClassPet, Reaction, Smooth, Power
	-- Color Settings
	Power.colorTapping = RUF.db.profile.Colors.Power.colorTapping
	Power.colorDisconnected = RUF.db.profile.Colors.Power.colorDisconnected
	Power.colorClass = RUF.db.profile.Colors.Power.colorClass
	Power.colorReaction = RUF.db.profile.Colors.Power.colorReaction
	Power.colorSmooth = RUF.db.profile.Colors.Power.colorSmooth
	Power.smoothGradient = RUF.db.profile.Colors.Power.BarGradient
	Power.colorPower = RUF.db.profile.Colors.Power.colorPower	
	Power.Smooth = RUF.db.profile.Colors.Power.Smooth -- Smoothly Animate
	if RUF.db.profile.unit[unit].Bars.ReverseFill == true then
		Power:SetFillStyle("REVERSE")
	else
		Power:SetFillStyle("STANDARD")
	end
	Power:SetHeight(RUF.db.profile.unit[unit].AdditionalPowerHeight)
	Power:SetPoint('BOTTOM',0,1)
	Power:SetPoint('LEFT',1,0)
	Power:SetPoint('RIGHT',-1,0)

	--Power:SetPoint('TOP',0,-1)
	--Power:SetPoint('LEFT',1,0)
	--Power:SetPoint('RIGHT',-1,0)
	Power:SetFrameLevel(5)
	
	-- Power Background
	-- Solid 75% Opacity.
    local PowerBG = Power:CreateTexture(nil, 'BACKGROUND')
	PowerBG:SetAllPoints(Power)
	PowerBG:SetPoint('TOP',0,1)
	local pType = select(1,UnitPowerType(unit))
	local r,g,b = unpack(RUF.db.profile.Colors.Power.PowerColor)
	PowerBG:SetTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.AdditionalPowerBG))
	PowerBG:SetColorTexture(r*0.35,g*0.35,b*0.35,0.75) -- 35% Brightness for the Background.
	PowerBG.colorSmooth = false
	Power.bg = PowerBG
	self.AdditionalPower = Power

	local _, unitClass = UnitClass(unit)
	if UnitPowerMax(unit, ADDITIONAL_POWER_BAR_INDEX) ~= 0 then
		if(ALT_MANA_BAR_PAIR_DISPLAY_INFO[unitClass]) then
			local powerType = UnitPowerType(unit)
			shouldEnable = ALT_MANA_BAR_PAIR_DISPLAY_INFO[unitClass][powerType]
		end
	end
	if not shouldEnable then
		self.AdditionalPower:Hide()
		self.AdditionalPower.bg:Hide()
		return
	end
end

local function ClassBarShow(self)
	if not ClassPowerID then return end
	if ClassVisibility == true then return end
	local UnitPowerMaxAmount = UnitPowerMax("player", ClassPowerID)
	if PlayerClass == "DEATHKNIGHT" then
		for index = 1, UnitPowerMaxAmount do
			self.Runes[index]:Show()
			self.RunesBG[index]:Show()
		end
	else
		for index = 1, UnitPowerMaxAmount do
			self.ClassPower[index]:Show()
			self.ClassPowerBG[index]:Show()
		end
	end


	ClassVisibility = true
	self.Health.bg:SetPoint('TOP',0, -(RUF.db.profile.unit["player"].ClassBarHeight - 1))
	self.Health.bg:SetPoint('BOTTOM',0,RUF.db.profile.unit["player"].PowerHeight)
end

local function ClassBarHide(self)
	if not ClassPowerID then return end
	if ClassVisibility == false then return end
	local UnitPowerMaxAmount = UnitPowerMax("player", ClassPowerID)

	if PlayerClass == "DEATHKNIGHT" then
		for index = 1, UnitPowerMaxAmount do
			self.Runes[index]:Hide()
			self.RunesBG[index]:Hide()
		end
	else
		for index = 1, UnitPowerMaxAmount do
			self.ClassPower[index]:Hide()
			self.ClassPowerBG[index]:Hide()
		end
	end


	ClassVisibility = false
	self.Health.bg:SetPoint('TOP',0, 0)
	self.Health.bg:SetPoint('BOTTOM',0,RUF.db.profile.unit["player"].PowerHeight)
end

local function ClassBarUpdate(self)
	-- if spec / spell isn't true, hide, if it is, show.
	if (ClassPowerID) then -- If we're a class that should show a class bar
		local UnitPowerMaxAmount = UnitPowerMax("player", ClassPowerID)
		if(not RequireSpec or RequireSpec == GetSpecialization()) then -- If the class requires a specific spec, and if so, if we are that spec.
			if(not RequireSpell or IsPlayerSpell(RequireSpell)) then -- If the class requires a specific spell, druid cat form.
				ClassBarShow(self)
				ClassVisibility = true
				self.colors.power.MANA = RUF.db.profile.Colors.PowerColors[0]
				self.colors.power.RAGE = RUF.db.profile.Colors.PowerColors[1]
				self.colors.power.FOCUS = RUF.db.profile.Colors.PowerColors[2]
				self.colors.power.ENERGY = RUF.db.profile.Colors.PowerColors[3]
				self.colors.power.COMBO_POINTS = RUF.db.profile.Colors.PowerColors[4]
				self.colors.power.RUNES = RUF.db.profile.Colors.PowerColors[5]
				self.colors.power.RUNIC_POWER = RUF.db.profile.Colors.PowerColors[6]
				self.colors.power.SOUL_SHARDS = RUF.db.profile.Colors.PowerColors[7]
				self.colors.power.LUNAR_POWER = RUF.db.profile.Colors.PowerColors[8]
				self.colors.power.HOLY_POWER = RUF.db.profile.Colors.PowerColors[9]
				self.colors.power.MAELSTROM = RUF.db.profile.Colors.PowerColors[11]
				self.colors.power.CHI = RUF.db.profile.Colors.PowerColors[12]
				self.colors.power.INSANITY = RUF.db.profile.Colors.PowerColors[13]
				self.colors.power.ARCANE_CHARGES = RUF.db.profile.Colors.PowerColors[16]
				self.colors.power.FURY = RUF.db.profile.Colors.PowerColors[17]
				self.colors.power.PAIN = RUF.db.profile.Colors.PowerColors[18]

				self.colors.runes[1] = RUF.db.profile.Colors.PowerColors[50]--Blood
				self.colors.runes[2] = RUF.db.profile.Colors.PowerColors[51]--Frost
				self.colors.runes[3] = RUF.db.profile.Colors.PowerColors[52]--Unholy

				local pr,pg,pb = unpack(self.colors.power[ClassPowerType])
				local UnitPowerMaxAmount = UnitPowerMax("player", ClassPowerID)
				local multiplier
				local constant = 10
				
				if PlayerClass == "DEATHKNIGHT" then
					local spec = GetSpecialization()
					if spec == 1 then --Blood
						pr,pg,pb = unpack(self.colors.runes[1])
						constant = 10
					elseif spec == 2 then -- Frost
						pr,pg,pb = unpack(self.colors.runes[2])
						constant = 10
					elseif spec == 3 then -- Unholy
						pr,pg,pb = unpack(self.colors.runes[3])
						constant = 10
					else -- WTF
						pr,pg,pb = unpack(self.colors.power[ClassPowerType])
					end
				end

				for index = 1, UnitPowerMaxAmount do
					multiplier = index
					if UnitPowerMaxAmount == 4 then
						multiplier = index +1
					end
					local curr = (pr*((((multiplier+constant)*6.6667)/100)))
					local curg = (pg*((((multiplier+constant)*6.6667)/100)))
					local curb = (pb*((((multiplier+constant)*6.6667)/100)))
					if PlayerClass == "DEATHKNIGHT" then
						local frames = {
							[1] = oUF_RUF_Player_Class1,
							[2] = oUF_RUF_Player_Class2,
							[3] = oUF_RUF_Player_Class3,
							[4] = oUF_RUF_Player_Class4,
							[5] = oUF_RUF_Player_Class5,
							[6] = oUF_RUF_Player_Class6,
						}
						self.Runes[index]:SetStatusBarColor(curr,curg,curb)
						--self.Runes.bg[index]:SetColorTexture(pr*0.75,pg*0.75,pb*0.75,0.5)
						frames[index]:SetStatusBarColor(curr,curg,curb)
					else
						self.ClassPower[index]:SetStatusBarColor(curr,curg,curb)
						--self.ClassPower.bg[index]:SetColorTexture(pr*0.75,pg*0.75,pb*0.75,0.5)
					end
				end
			else
				ClassBarHide(self)
				ClassVisibility = false
			end
		else
			ClassBarHide(self)
			ClassVisibility = false
		end
	else
		ClassBarHide(self)
		ClassVisibility = false
	end
end

local function SetClassBar(self, unit)	
	local ClassPower = {}
	local ClassPowerBG = {}
	if not ClassPowerID then return end -- Do nothing for classes that can never have a class bar.
	local UnitPowerMaxAmount = UnitPowerMax(unit, ClassPowerID)
	local BarParent = CreateFrame('Frame', self:GetName() .. ".ClassPower", self)
    for index = 1, UnitPowerMaxAmount do
		local BarBG = CreateFrame('Frame', 'oUF_RUF_Player_Class'..index..'Parent', BarParent)
		local Bar = CreateFrame('StatusBar', 'oUF_RUF_Player_Class'..index, BarBG)
		local size = (RUF.db.profile.unit["player"].Width + (UnitPowerMaxAmount - 1))  / UnitPowerMaxAmount -- Scale size to fit with 1 Pixel Border
		BarBG:SetWidth(size)
		BarBG:SetHeight(RUF.db.profile.unit["player"].ClassBarHeight)
		BarBG:SetPoint('TOPLEFT', self, 'TOPLEFT', ((index - 1) * size - ((index - 1 ) * 1)), 0) -- Scale size to fit with 1 Pixel Border
		
		-- Set Pixel Border
		BarBG:SetBackdrop(RUF.db.profile.FrameBorder)
		BarBG:SetBackdropBorderColor(0,0,0,1)

		-- Set bars to fill BarBG, leaving room for the border
		Bar:SetHeight(RUF.db.profile.unit["player"].ClassBarHeight-2)
		Bar:SetReverseFill(RUF.db.profile.unit["player"].Bars.ReverseFill)
		Bar:SetPoint('BOTTOM',0,1)
		Bar:SetPoint('LEFT',1,0)
		Bar:SetPoint('RIGHT',-1,0)
		local statusBarTexture = LSM:Fetch("statusbar", RUF.db.profile.Texture.Class)
		Bar:SetStatusBarTexture(statusBarTexture)
		Bar:SetFrameLevel(5)

		-- Create Backdrop
		local pr,pg,pb = unpack(self.colors.power[ClassPowerType])
		local SolidBG = BarBG:CreateTexture("oUF_RUF_Player_Class"..index.."BG", "BACKGROUND")
		SolidBG:SetAllPoints(BarBG)
		SolidBG:SetTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.ClassBG))
		SolidBG:SetColorTexture(pr*0.35, pg*0.35, pb*0.35, 0.75)  -- 50% Brightness for the Background.
		
		ClassPower[index] = Bar
		ClassPowerBG[index] = BarBG
	end

	-- Move Healthbar BG down so there is no background overlap
	self.Health.bg:SetPoint('TOP',0, -(RUF.db.profile.unit["player"].ClassBarHeight - 1))
	self.Health.bg:SetPoint('BOTTOM',0,RUF.db.profile.unit["player"].PowerHeight)
	
	-- Register with oUF
	if PlayerClass == "DEATHKNIGHT" then
		self.Runes = ClassPower
		self.RunesBG = ClassPowerBG	
		self.Runes.bg = SolidBG
		self:RegisterEvent('ACTIONBAR_UPDATE_STATE',ClassBarUpdate)
		self:RegisterEvent('UNIT_POWER',ClassBarUpdate)
		self:RegisterEvent('UNIT_DISPLAYPOWER',ClassBarUpdate)
		self:RegisterEvent('PLAYER_ENTERING_WORLD',ClassBarUpdate)
	else
		self.ClassPower = ClassPower
		self.ClassPowerBG = ClassPowerBG	
		self.ClassPower.bg = SolidBG
		self:RegisterEvent('PLAYER_TALENT_UPDATE',ClassBarUpdate)
		self:RegisterEvent('UNIT_POWER',ClassBarUpdate)
		self:RegisterEvent('UNIT_DISPLAYPOWER',ClassBarUpdate)
		self:RegisterEvent('PLAYER_ENTERING_WORLD',ClassBarUpdate)
	end
	ClassBarUpdate(self)	
end

local function AbsorbBarUpdate(self, event, unit)
	local unitframes = {
		["player"] = oUF_RUF_Player,
		["pet"] = oUF_RUF_Pet,
		["target"] = oUF_RUF_Target,
		["targettarget"] = oUF_RUF_TargetTarget,
		["focus"] = oUF_RUF_Focus,
		["focustarget"] = oUF_RUF_FocusTarget,
		["boss1"] = oUF_RUF_Boss1,
		["boss2"] = oUF_RUF_Boss2,
		["boss3"] = oUF_RUF_Boss3,
		["boss4"] = oUF_RUF_Boss4,
		["boss5"] = oUF_RUF_Boss5,
		["arena1"] = oUF_RUF_Arena1,
		["arena2"] = oUF_RUF_Arena2,
		["arena3"] = oUF_RUF_Arena3,
		["arena4"] = oUF_RUF_Arena4,
		["arena5"] = oUF_RUF_Arena5,
		["party1"] = oUF_RUF_RaidUnitButton1,
		["party2"] = oUF_RUF_RaidUnitButton2,
		["party3"] = oUF_RUF_RaidUnitButton3,
		["party4"] = oUF_RUF_RaidUnitButton4,
		["party5"] = oUF_RUF_RaidUnitButton5,
	}
	local units = {
		[1] = "player",
		[2] = "pet",
		[3] = "target",
		[4] = "targettarget",
		[5] = "focus",
		--[0] = "focustarget",
		[6] = "boss1",
		[7] = "boss2",
		[8] = "boss3",
		[9] = "boss4",
		[10] = "boss5",
		[11] = "arena1",
		[12] = "arena2",
		[13] = "arena3",
		[14] = "arena4",
		[15] = "arena5",
		[16] = "party1",
		[17] = "party2",
		[18] = "party3",
		[19] = "party4",
		[20] = "party5",
	}
	if event == "PLAYER_TARGET_CHANGED" or event == "UNIT_TARGET" then
		for k,v in pairs(units) do
			if UnitExists(v) then
				if unitframes[v] then
					local AbsorbAmount = (UnitGetTotalAbsorbs(v) or 0)
					local max = (UnitHealthMax(v) or 0)
					local r,g,b,a = unpack(RUF.db.profile.Colors.MiscColors.Absorb)
					unitframes[v].Absorb:SetMinMaxValues(0, max)
					unitframes[v].Absorb:SetValue(AbsorbAmount)
					unitframes[v].Absorb:SetStatusBarColor(r,g,b,a)
				end
			end
		end
	elseif event == "UNIT_ABSORB_AMOUNT_CHANGED" then
		local AbsorbAmount = (UnitGetTotalAbsorbs(unit) or 0)
		if UnitHealthMax(unit) then
			local max = (UnitHealthMax(unit) or 0)
			local r,g,b,a = unpack(RUF.db.profile.Colors.MiscColors.Absorb)
			--/run print(_G["oUF_RUF_Player"]:GetName())
			if unitframes[unit] then
				unitframes[unit].Absorb:SetMinMaxValues(0, max)
				unitframes[unit].Absorb:SetValue(AbsorbAmount)
				unitframes[unit].Absorb:SetStatusBarColor(r,g,b,a)
			end
		end
		--if UnitExists(unit.."target") then
		if UnitExists("targettarget") then
			--local AbsorbAmount = (UnitGetTotalAbsorbs(unit.."target") or 0)
			local AbsorbAmount = (UnitGetTotalAbsorbs("targettarget") or 0)
			--local max = (UnitHealthMax(unit.."target") or 0)
			local max = (UnitHealthMax("targettarget") or 0)
			local r,g,b,a = unpack(RUF.db.profile.Colors.MiscColors.Absorb)
			--if _G[unitframes[unit .. "target"]] then
			--if _G[unitframes["targettarget"]] then
			--	unitframes[unit.."target"].Absorb:SetMinMaxValues(0, max)
			--	unitframes[unit.."target"].Absorb:SetValue(AbsorbAmount)
			--	unitframes[unit.."target"].Absorb:SetStatusBarColor(r,g,b,a)
				unitframes["targettarget"].Absorb:SetMinMaxValues(0, max)
				unitframes["targettarget"].Absorb:SetValue(AbsorbAmount)
				unitframes["targettarget"].Absorb:SetStatusBarColor(r,g,b,a)
			--end
		end
	end
end

local function SetAbsorbBar(self, unit)
	-- Absorb Bar
	local Absorb = CreateFrame('StatusBar', nil, self)
	local statusBarTexture = LSM:Fetch("statusbar", RUF.db.profile.Texture.Absorb)
	Absorb:SetStatusBarTexture(statusBarTexture)
	Absorb.Smooth = RUF.db.profile.Colors.Health.Smooth -- Smoothly Animate
	Absorb:SetHeight(RUF.db.profile.unit[unit].Height-2)
	Absorb:SetReverseFill(RUF.db.profile.unit[unit].Bars.ReverseFill)
    Absorb:SetPoint('TOP',0,-1)
    Absorb:SetPoint('LEFT',1,0)
    Absorb:SetPoint('RIGHT',-1,0)
	Absorb:SetFrameLevel(2)
	local AbsorbAmount = (UnitGetTotalAbsorbs(unit))
	local r,g,b,a = unpack(RUF.db.profile.Colors.MiscColors.Absorb)
	local min = 0
	local max = UnitHealthMax(unit)
	Absorb:SetMinMaxValues(min, max)
	Absorb:SetValue(AbsorbAmount)
	Absorb:SetStatusBarColor(r,g,b,a)

	-- Health Background
	-- Solid 75% Opacity.
    --[[local AbsorbBG = Health:CreateTexture(nil, 'BACKGROUND')
	AbsorbBG:SetHeight((RUF.db.profile.unit[unit].Height - RUF.db.profile.unit[unit].PowerHeight) - 2)
    AbsorbBG:SetPoint('TOP',0,0)
    AbsorbBG:SetPoint('LEFT',0,0)
	AbsorbBG:SetPoint('RIGHT',0,0)
	AbsorbBG:SetTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.HealthBG))
	AbsorbBG:SetColorTexture(0, 0, 0, 0.75)
	Absorb.bg = AbsorbBG]]--
	
	self.Absorb = Absorb
	self:RegisterEvent('UNIT_ABSORB_AMOUNT_CHANGED',AbsorbBarUpdate)
	self:RegisterEvent('UNIT_TARGET',AbsorbBarUpdate)
	self:RegisterEvent('PLAYER_TARGET_CHANGED',AbsorbBarUpdate)
end

local function SetNameText(self, unit, event) -- DONE
	-- We create a parent for strings so that they appear above everything else
	local StringParent = CreateFrame('Frame', self:GetName() .. ".NameTextParent", self)
	StringParent:SetFrameLevel(20)
	self.NameTextParent = StringParent

	local NameText = self.NameTextParent:CreateFontString(self:GetName() .. ".NameTextParent.NameText", 'OVERLAY', "Raeli")
	NameText:SetPoint(RUF.db.profile.unit[unit].Position.Text.Name.AnchorPoint, self, RUF.db.profile.unit[unit].Position.Text.Name.x, RUF.db.profile.unit[unit].Position.Text.Name.y)
	local Font = ""
	if RUF.db.profile.unit[unit].Font.Name.Type ~= "" then
		Font = LSM:Fetch("font", RUF.db.profile.unit[unit].Font.Name.Type)
	else	
		Font = LSM:Fetch("font", RUF.db.profile.Font.Name.Type)
	end
	NameText:SetFont((Font), RUF.db.profile.unit[unit].Font.Name.Size, RUF.db.profile.unit[unit].Font.Name.Outline)
	NameText:SetShadowOffset(1, -1)
	NameText:SetTextColor(1, 1, 1, 1)
	local AnchorPoint = RUF.db.profile.unit[unit].Position.Text.Name.AnchorPoint
	if AnchorPoint == "RIGHT" or AnchorPoint == "TOPRIGHT" or AnchorPoint == "BOTTOMRIGHT" then
		NameText:SetJustifyH("RIGHT")
	elseif AnchorPoint == "LEFT" or AnchorPoint == "TOPLEFT" or AnchorPoint == "BOTTOMLEFT" then
		NameText:SetJustifyH("LEFT")
	else
		NameText:SetJustifyH("CENTER")
	end
	NameText:SetWordWrap(false)
	self.NameTextParent.NameText = NameText
	self:Tag(NameText, RUF.db.profile.unit[unit].Tags.Name)	
end

local function SetHealthText(self, unit) -- DONE
	-- We create a parent for strings so that they appear above everything else
	local StringParent = CreateFrame('Frame', self:GetName() .. ".HealthTextParent", self)
	StringParent:SetFrameLevel(20)
	self.HealthTextParent = StringParent

	local HealthText = self.HealthTextParent:CreateFontString(self:GetName() .. ".HealthTextParent.HealthText", 'OVERLAY')
	HealthText:SetPoint(RUF.db.profile.unit[unit].Position.Text.Health.AnchorPoint, self, RUF.db.profile.unit[unit].Position.Text.Health.x, RUF.db.profile.unit[unit].Position.Text.Health.y)
	local Font = ""
	if RUF.db.profile.unit[unit].Font.Health.Type ~= "" then
		Font = LSM:Fetch("font", RUF.db.profile.unit[unit].Font.Health.Type)
	else	
		Font = LSM:Fetch("font", RUF.db.profile.Font.Health.Type)
	end
	HealthText:SetFont((Font), RUF.db.profile.unit[unit].Font.Health.Size, RUF.db.profile.unit[unit].Font.Health.Outline)
	HealthText:SetShadowOffset(1, -1)
	HealthText:SetTextColor(1, 1, 1, 1)
	local AnchorPoint = RUF.db.profile.unit[unit].Position.Text.Health.AnchorPoint
	if AnchorPoint == "RIGHT" or AnchorPoint == "TOPRIGHT" or AnchorPoint == "BOTTOMRIGHT" then
		HealthText:SetJustifyH("RIGHT")
	elseif AnchorPoint == "LEFT" or AnchorPoint == "TOPLEFT" or AnchorPoint == "BOTTOMLEFT" then
		HealthText:SetJustifyH("LEFT")
	else
		HealthText:SetJustifyH("CENTER")
	end
	HealthText:SetWordWrap(false)
	self.HealthTextParent.HealthText = HealthText
	self:Tag(HealthText, RUF.db.profile.unit[unit].Tags.Health)
end

local function SetPowerText(self, unit) -- TODO Frequent Updates
	-- We create a parent for strings so that they appear above everything else
	local StringParent = CreateFrame('Frame', self:GetName() .. ".PowerTextParent", self)
	StringParent:SetFrameLevel(20)
	self.PowerTextParent = StringParent
	
	local PowerText = self.PowerTextParent:CreateFontString(self:GetName() .. ".PowerTextParent.PowerText", 'OVERLAY', "Raeli")
	PowerText:SetPoint(RUF.db.profile.unit[unit].Position.Text.Power.AnchorPoint, self, RUF.db.profile.unit[unit].Position.Text.Power.x, RUF.db.profile.unit[unit].Position.Text.Power.y)
	local Font = ""
	if RUF.db.profile.unit[unit].Font.Power.Type ~= "" then
		Font = LSM:Fetch("font", RUF.db.profile.unit[unit].Font.Power.Type)
	else	
		Font = LSM:Fetch("font", RUF.db.profile.Font.Power.Type)
	end
	PowerText:SetFont((Font), RUF.db.profile.unit[unit].Font.Power.Size, RUF.db.profile.unit[unit].Font.Power.Outline)
	PowerText:SetShadowOffset(1, -1)
	PowerText:SetTextColor(1, 1, 1, 1)
	local AnchorPoint = RUF.db.profile.unit[unit].Position.Text.Power.AnchorPoint
	if AnchorPoint == "RIGHT" or AnchorPoint == "TOPRIGHT" or AnchorPoint == "BOTTOMRIGHT" then
		PowerText:SetJustifyH("RIGHT")
	elseif AnchorPoint == "LEFT" or AnchorPoint == "TOPLEFT" or AnchorPoint == "BOTTOMLEFT" then
		PowerText:SetJustifyH("LEFT")
	else
		PowerText:SetJustifyH("CENTER")
	end
	PowerText:SetWordWrap(false)
	self.PowerTextParent.PowerText = PowerText
	self:Tag(PowerText, RUF.db.profile.unit[unit].Tags.Power)
end

local function SetAdditionalPowerText(self, unit) -- TODO Frequent Updates
	-- We create a parent for strings so that they appear above everything else
	local StringParent = CreateFrame('Frame', self:GetName() .. ".AdditionalPowerTextParent", self)
	StringParent:SetFrameLevel(20)
	self.AdditionalPowerTextParent = StringParent
	local AdditionalPowerText = self.AdditionalPowerTextParent:CreateFontString(self:GetName() .. ".AdditionalPowerTextParent.AdditionalPowerText", 'OVERLAY', "Raeli")
	AdditionalPowerText:SetPoint(RUF.db.profile.unit[unit].Position.AdditionalPower.AnchorPoint, self, RUF.db.profile.unit[unit].Position.AdditionalPower.x, RUF.db.profile.unit[unit].Position.AdditionalPower.y)
	local Font = ""
	if RUF.db.profile.unit[unit].Font.AdditionalPower.Type ~= "" then
		Font = LSM:Fetch("font", RUF.db.profile.unit[unit].Font.AdditionalPower.Type)
	else	
		Font = LSM:Fetch("font", RUF.db.profile.Font.AdditionalPower.Type)
	end
	AdditionalPowerText:SetFont((Font), RUF.db.profile.unit[unit].Font.AdditionalPower.Size, RUF.db.profile.unit[unit].Font.AdditionalPower.Outline)
	AdditionalPowerText:SetShadowOffset(1, -1)
	AdditionalPowerText:SetTextColor(1, 1, 1, 1)
	local AnchorPoint = RUF.db.profile.unit[unit].Position.AdditionalPower.AnchorPoint
	if AnchorPoint == "RIGHT" or AnchorPoint == "TOPRIGHT" or AnchorPoint == "BOTTOMRIGHT" then
		AdditionalPowerText:SetJustifyH("RIGHT")
	elseif AnchorPoint == "LEFT" or AnchorPoint == "TOPLEFT" or AnchorPoint == "BOTTOMLEFT" then
		AdditionalPowerText:SetJustifyH("LEFT")
	else
		AdditionalPowerText:SetJustifyH("CENTER")
	end
	AdditionalPowerText:SetWordWrap(false)
	self.AdditionalPowerTextParent.AdditionalPowerText = AdditionalPowerText
	self:Tag(AdditionalPowerText, RUF.db.profile.unit[unit].Tags.AdditionalPower)
end

local function SetLevelText(self, unit) -- DONE
	-- We create a parent for strings so that they appear above everything else		
	local StringParent = CreateFrame('Frame',self:GetName() .. ".LevelTextParent", self)
	StringParent:SetFrameLevel(20)
	self.LevelTextParent = StringParent
	
	local LevelText = self.LevelTextParent:CreateFontString(self:GetName() .. ".LevelTextParent.LevelText", 'OVERLAY', "Raeli")
	LevelText:SetPoint(RUF.db.profile.unit[unit].Position.Text.Level.AnchorPoint, self, RUF.db.profile.unit[unit].Position.Text.Level.x, RUF.db.profile.unit[unit].Position.Text.Level.y)
	local Font = ""
	if RUF.db.profile.unit[unit].Font.Level.Type ~= "" then
		Font = LSM:Fetch("font", RUF.db.profile.unit[unit].Font.Level.Type)
	else	
		Font = LSM:Fetch("font", RUF.db.profile.Font.Level.Type)
	end
	LevelText:SetFont((Font), RUF.db.profile.unit[unit].Font.Level.Size, RUF.db.profile.unit[unit].Font.Level.Outline)
	LevelText:SetShadowOffset(1, -1)
	LevelText:SetTextColor(1, 1, 1, 1)
	local AnchorPoint = RUF.db.profile.unit[unit].Position.Text.Level.AnchorPoint
	if AnchorPoint == "RIGHT" or AnchorPoint == "TOPRIGHT" or AnchorPoint == "BOTTOMRIGHT" then
		LevelText:SetJustifyH("RIGHT")
	elseif AnchorPoint == "LEFT" or AnchorPoint == "TOPLEFT" or AnchorPoint == "BOTTOMLEFT" then
		LevelText:SetJustifyH("LEFT")
	else
		LevelText:SetJustifyH("CENTER")
	end
	LevelText:SetWordWrap(false)
	self.LevelTextParent.LevelText = LevelText
	self:Tag(LevelText, RUF.db.profile.unit[unit].Tags.Level)	
end


------------------------ !CLASSCOLORS OVERRIDE
-- Override Config with !ClassColors addon settings, so you can easily adjust in game. 
-- Feel free to remove everything in this section if you want to only use the values above.
local function SetClassColors()
	local function customClassColors()
		if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then
			local function updateColors()
				for classToken, color in next, CUSTOM_CLASS_COLORS do
					RUF.db.profile.Colors.ClassColors[classToken] = {(color.r), (color.g), (color.b)}				
				end
				for _, obj in next, oUF.objects do
					obj:UpdateAllElements('CUSTOM_CLASS_COLORS')
				end
			end
			updateColors()
			CUSTOM_CLASS_COLORS:RegisterCallback(updateColors)
			return true
		end
	end


	if(not customClassColors()) then
		local eventHandler = CreateFrame('Frame')
		eventHandler:RegisterEvent('ADDON_LOADED')
		eventHandler:SetScript('OnEvent', function(self)
			if(customClassColors()) then
				self:UnregisterEvent('ADDON_LOADED')
				self:SetScript('OnEvent', nil)
			end
		end)
	end
end
------------------------ !CLASSCOLORS OVERRIDE

local function SetupFrames(self, unit)
	unit = unit:match('^(.-)%d+') or unit
	-- Set Colours
	SetClassColors()
	self.colors.Tapping = RUF.db.profile.Colors.MiscColors.Tapping
	self.colors.Disconnected = RUF.db.profile.Colors.MiscColors.Disconnected
	self.colors.class.DEATHKNIGHT = RUF.db.profile.Colors.ClassColors.DEATHKNIGHT
	self.colors.class.DEMONHUNTER = RUF.db.profile.Colors.ClassColors.DEMONHUNTER
	self.colors.class.DRUID = RUF.db.profile.Colors.ClassColors.DRUID
	self.colors.class.HUNTER = RUF.db.profile.Colors.ClassColors.HUNTER
	self.colors.class.MAGE = RUF.db.profile.Colors.ClassColors.MAGE
	self.colors.class.MONK = RUF.db.profile.Colors.ClassColors.MONK
	self.colors.class.PALADIN = RUF.db.profile.Colors.ClassColors.PALADIN
	self.colors.class.PRIEST = RUF.db.profile.Colors.ClassColors.PRIEST
	self.colors.class.ROGUE = RUF.db.profile.Colors.ClassColors.ROGUE
	self.colors.class.SHAMAN = RUF.db.profile.Colors.ClassColors.SHAMAN
	self.colors.class.WARLOCK = RUF.db.profile.Colors.ClassColors.WARLOCK
	self.colors.class.WARRIOR = RUF.db.profile.Colors.ClassColors.WARRIOR
	
	for i = 1,8 do
		self.colors.reaction[i][1] = RUF.db.profile.Colors.ReactionColors[i][1]
		self.colors.reaction[i][2] = RUF.db.profile.Colors.ReactionColors[i][2]
		self.colors.reaction[i][3] = RUF.db.profile.Colors.ReactionColors[i][3]
	end
	self.colors.health = RUF.db.profile.Colors.Health.HealthColor
	self.colors.power.MANA = RUF.db.profile.Colors.PowerColors[0]
	self.colors.power.RAGE = RUF.db.profile.Colors.PowerColors[1]
	self.colors.power.FOCUS = RUF.db.profile.Colors.PowerColors[2]
	self.colors.power.ENERGY = RUF.db.profile.Colors.PowerColors[3]
	self.colors.power.COMBO_POINTS = RUF.db.profile.Colors.PowerColors[4]
	self.colors.power.RUNES = RUF.db.profile.Colors.PowerColors[5]
	self.colors.power.RUNIC_POWER = RUF.db.profile.Colors.PowerColors[6]
	self.colors.power.SOUL_SHARDS = RUF.db.profile.Colors.PowerColors[7]
	self.colors.power.LUNAR_POWER = RUF.db.profile.Colors.PowerColors[8]
	self.colors.power.HOLY_POWER = RUF.db.profile.Colors.PowerColors[9]
	self.colors.power.MAELSTROM = RUF.db.profile.Colors.PowerColors[11]
	self.colors.power.CHI = RUF.db.profile.Colors.PowerColors[12]
	self.colors.power.INSANITY = RUF.db.profile.Colors.PowerColors[13]
	self.colors.power.ARCANE_CHARGES = RUF.db.profile.Colors.PowerColors[16]
	self.colors.power.FURY = RUF.db.profile.Colors.PowerColors[17]
	self.colors.power.PAIN = RUF.db.profile.Colors.PowerColors[18]

	self.colors.runes[1] = RUF.db.profile.Colors.PowerColors[50]--Blood
	self.colors.runes[2] = RUF.db.profile.Colors.PowerColors[51]--Frost
	self.colors.runes[3] = RUF.db.profile.Colors.PowerColors[52]--Unholy

	RUF.db.profile.unit.boss1 = RUF.db.profile.unit.boss
	RUF.db.profile.unit.boss2 = RUF.db.profile.unit.boss
	RUF.db.profile.unit.boss3 = RUF.db.profile.unit.boss
	RUF.db.profile.unit.boss4 = RUF.db.profile.unit.boss

	RUF.db.profile.unit.arena1 = RUF.db.profile.unit.arena
	RUF.db.profile.unit.arena2 = RUF.db.profile.unit.arena
	RUF.db.profile.unit.arena3 = RUF.db.profile.unit.arena
	RUF.db.profile.unit.arena4 = RUF.db.profile.unit.arena
	RUF.db.profile.unit.arena5 = RUF.db.profile.unit.arena

	RUF.db.profile.unit.party1 = RUF.db.profile.unit.party
	RUF.db.profile.unit.party2 = RUF.db.profile.unit.party
	RUF.db.profile.unit.party3 = RUF.db.profile.unit.party
	RUF.db.profile.unit.party4 = RUF.db.profile.unit.party


	
	self:RegisterForClicks('AnyUp')
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	-- Frame Border
	self:SetBackdrop(RUF.db.profile.FrameBorder)
	self:SetBackdropBorderColor(0,0,0,1)
	self:SetHeight(RUF.db.profile.unit[unit].Height)
	self:SetWidth(RUF.db.profile.unit[unit].Width)
	self:SetClampedToScreen(true)

	-- Setup Elements
	SetHealth(self, unit) -- Always set this up.
	SetPower(self, unit)
	self.Power.PostUpdate = PowerPostUpdate

	

	self.Health.PostUpdate = HealthPostUpdate
	if (unit == 'player') and RUF.db.profile.unit[unit].Bars.Class then -- Only setup on player targer.
		SetClassBar(self, unit)
		SetAdditionalPower(self, unit)
		self.AdditionalPower.PostUpdate = AdditionalPowerPostUpdate
	end
	if unit == 'targettarget' then
		self.onUpdateFrequency	= 1-- TODO Option
	else
		self.onUpdateFrequency	= 1
	end
	if RUF.db.profile.unit[unit].Bars.Absorb == 1 then -- To do. Setup Bar overlay over Healthbar
		SetAbsorbBar(self, unit)
	elseif RUF.db.profile.unit[unit].Bars.Absorb == 2 then -- To do. Setup Bar as separate bar.
		-- SetAbsorbBar(self, unit)
	end

	SetNameText(self, unit)
	SetHealthText(self, unit)
	SetPowerText(self, unit)
	--SetAdditionalPowerText(self, unit)
	SetLevelText(self, unit)
	if RUF.db.profile.unit[unit].Texts.Name == false then
		self.NameTextParent:Hide()
	end
	if RUF.db.profile.unit[unit].Texts.Health == false then
		self.HealthTextParent:Hide()
	end
	if RUF.db.profile.unit[unit].Texts.Power == 0 then
		self.PowerTextParent:Hide()
	elseif RUF.db.profile.unit[unit].Texts.Power == 1 and UnitPower(unit) == 0 then
		self.PowerTextParent:Hide()
	else
		self.PowerTextParent:Hide()
	end
	if RUF.db.profile.unit[unit].Texts.Level == false then
		self.LevelTextParent:Hide()
	end
end





oUF:RegisterStyle('RUF_', SetupFrames)
oUF:Factory(function(self)
	self:SetActiveStyle('RUF_')
	self:Spawn('player'):SetPoint(
		RUF.db.profile.unit["player"].Position.Frame.AnchorPoint,
		RUF.db.profile.unit["player"].Position.Frame.Anchor,
		RUF.db.profile.unit["player"].Position.Frame.AnchorTo,
		RUF.db.profile.unit["player"].Position.Frame.x,
		RUF.db.profile.unit["player"].Position.Frame.y)
	self:Spawn('pet'):SetPoint(
		RUF.db.profile.unit["pet"].Position.Frame.AnchorPoint,
		RUF.db.profile.unit["pet"].Position.Frame.Anchor,
		RUF.db.profile.unit["pet"].Position.Frame.AnchorTo,
		RUF.db.profile.unit["pet"].Position.Frame.x,
		RUF.db.profile.unit["pet"].Position.Frame.y)
	self:Spawn('focus'):SetPoint(
		RUF.db.profile.unit["focus"].Position.Frame.AnchorPoint,
		RUF.db.profile.unit["focus"].Position.Frame.Anchor,
		RUF.db.profile.unit["focus"].Position.Frame.AnchorTo,
		RUF.db.profile.unit["focus"].Position.Frame.x,
		RUF.db.profile.unit["focus"].Position.Frame.y)
	self:Spawn('target'):SetPoint(
		RUF.db.profile.unit["target"].Position.Frame.AnchorPoint,
		RUF.db.profile.unit["target"].Position.Frame.Anchor,
		RUF.db.profile.unit["target"].Position.Frame.AnchorTo,
		RUF.db.profile.unit["target"].Position.Frame.x,
		RUF.db.profile.unit["target"].Position.Frame.y)
	self:Spawn('targettarget'):SetPoint(
		RUF.db.profile.unit["targettarget"].Position.Frame.AnchorPoint,
		RUF.db.profile.unit["targettarget"].Position.Frame.Anchor,
		RUF.db.profile.unit["targettarget"].Position.Frame.AnchorTo,
		RUF.db.profile.unit["targettarget"].Position.Frame.x,
		RUF.db.profile.unit["targettarget"].Position.Frame.y)

	--self:SpawnHeader(nil, nil, 'custom [group:raid][nogroup] hide;show',
	--	'showParty', true,
	--	'showRaid', false,
--		'yOffset', -6,
--		'oUF-initialConfigFunction', [[
--			self:SetHeight(19)
--			self:SetWidth(126)
--		]]
--	):SetPoint('BOTTOMLEFT', 4, 4)

local party = oUF:SpawnHeader(
    -- 'oUF_RUF_Party', nil, 'solo', 'showSolo', true,  -- debug
		'oUF_RUF_Party', nil, 'party',
		'showSolo', false,
		'showParty', true,
		'showRaid', false,
		'showPlayer', false,
		'yOffset', -4,
		'Point', 'TOP'
	):SetPoint(
		RUF.db.profile.unit["party"].Position.Frame.AnchorPoint,
		RUF.db.profile.unit["party"].Position.Frame.Anchor,
		RUF.db.profile.unit["party"].Position.Frame.AnchorTo,
		RUF.db.profile.unit["party"].Position.Frame.x,
		RUF.db.profile.unit["party"].Position.Frame.y)

	--[[for index = 1,4 do
		local party = self:Spawn('party' .. index)
		if index == 1 then
			party:SetPoint(
				RUF.db.profile.unit["party1"].Position.Frame.AnchorPoint,
				RUF.db.profile.unit["party1"].Position.Frame.Anchor,
				RUF.db.profile.unit["party1"].Position.Frame.AnchorTo,
				RUF.db.profile.unit["party1"].Position.Frame.x,
				RUF.db.profile.unit["party1"].Position.Frame.y)
		else
			party:SetPoint('BOTTOM', _G['oUF_RUF_Party' .. index - 1], 'TOP', 0, 4)
		end

	end]]--

	for index = 1, 4 do
		local boss = self:Spawn('boss' .. index)

		if(index == 1) then
			--boss:SetPoint('TOPLEFT', oUF_RUF_Focus, 'BOTTOMLEFT', 0, -4)

			boss:SetPoint(
				RUF.db.profile.unit.boss.Position.Frame.AnchorPoint,
				RUF.db.profile.unit.boss.Position.Frame.Anchor,
				RUF.db.profile.unit.boss.Position.Frame.AnchorTo,
				RUF.db.profile.unit.boss.Position.Frame.x,
				RUF.db.profile.unit.boss.Position.Frame.y)
		else
			boss:SetPoint('TOP', _G['oUF_RUF_Boss' .. index - 1], 'BOTTOM', 0, -4)
		end
	end
	for index = 1, 5 do
		local arena = self:Spawn('arena' .. index)

		if(index == 1) then
			--arena:SetPoint('TOPLEFT', oUF_RUF_Focus, 'BOTTOMLEFT', 0, -20)

			arena:SetPoint(
				RUF.db.profile.unit.arena.Position.Frame.AnchorPoint,
				RUF.db.profile.unit.arena.Position.Frame.Anchor,
				RUF.db.profile.unit.arena.Position.Frame.AnchorTo,
				RUF.db.profile.unit.arena.Position.Frame.x,
				RUF.db.profile.unit.arena.Position.Frame.y)
		else
			arena:SetPoint('TOP', _G['oUF_RUF_Arena' .. index - 1], 'BOTTOM', 0, -4) -- TODO: Add Option to change growth direction
		end
	end
end)
