------------------------------------------------
---- Raeli's Unit Frames Options Module ----
------------------------------------------------

local RUF = LibStub("AceAddon-3.0"):GetAddon("RUF")
RUF.Callbacks = RUF.Callbacks or LibStub("CallbackHandler-1.0"):New(RUF)
local L = LibStub("AceLocale-3.0"):GetLocale("RUF")
local RUF_O = RUF:NewModule("RUF_Options")
local LSM = LibStub("LibSharedMedia-3.0")
local _, ns = ...
local oUF = ns.oUF
local DefaultOptions = RUF_cfg
local cfg
------------------------
---- Global Options ----
------------------------
local units = {
	[1] = oUF_RUF_Player,
	[2] = oUF_RUF_Pet,
	[3] = oUF_RUF_Target,
	[4] = oUF_RUF_TargetTarget,
	[5] = oUF_RUF_Focus,
	--[0] = oUF_RUF_FocusTarget,
	[6] = oUF_RUF_Boss1,
	[7] = oUF_RUF_Boss2,
	[8] = oUF_RUF_Boss3,
	[9] = oUF_RUF_Boss4,
	[10] = oUF_RUF_Arena1,
	[11] = oUF_RUF_Arena2,
	[12] = oUF_RUF_Arena3,
	[13] = oUF_RUF_Arena4,
	[14] = oUF_RUF_Arena5,
	[15] = oUF_RUF_Party1,
	[16] = oUF_RUF_Party2,
	[17] = oUF_RUF_Party3,
	[18] = oUF_RUF_Party4,
}

local unitnames = {
	[1] = "player",
	[2] = "pet",
	[3] = "target",
	[4] = "targettarget",
	[5] = "focus",
	--[0] = "focustarget",
	[6] = "boss1",
	[7] = "boss2",
	[8] = "boss3",
	[9] = "boss4",
	[10] = "arena1",
	[11] = "arena2",
	[12] = "arena3",
	[13] = "arena4",
	[14] = "arena5",
	[15] = "party1",
	[16] = "party2",
	[17] = "party3",
	[18] = "party4",
}

local unitframes = {
	["player"] = oUF_RUF_Player,
	["pet"] = oUF_RUF_Pet,
	["target"] = oUF_RUF_Target,
	["targettarget"] = oUF_RUF_TargetTarget,
	["focus"] = oUF_RUF_Focus,
	["focustarget"] = oUF_RUF_FocusTarget,
	["boss1"] = oUF_RUF_Boss1,
	["boss2"] = oUF_RUF_Boss2,
	["boss3"] = oUF_RUF_Boss3,
	["boss4"] = oUF_RUF_Boss4,
	["arena1"] = oUF_RUF_Arena1,
	["arena2"] = oUF_RUF_Arena2,
	["arena3"] = oUF_RUF_Arena3,
	["arena4"] = oUF_RUF_Arena4,
	["arena5"] = oUF_RUF_Arena5,
	["party1"] = oUF_RUF_Party1,
	["party2"] = oUF_RUF_Party2,
	["party3"] = oUF_RUF_Party3,
	["party4"] = oUF_RUF_Party4,
}


--[ZZ[index][name]]
local ZZ = {}



local Tags = {
	['Raeli:Level']="Raeli:Level",
	['Raeli:UpperName']="Raeli:UpperName",
	['Raeli:AFKDND']="Raeli:AFKDND",
	['Raeli:FullHealth']="Raeli:FullHealth",
	['Raeli:Power']="Raeli:Power",
}

local Texts = {
	[1] = { 
		name = "Name",
		frame = "NameText",
	},
	[2] = {
		name = "Health",
		frame = "HealthText",
	},
	[3] = {
		name = "Power",
		frame = "PowerText",
	},
	[4] = {
		name = "Level",
		frame = "LevelText",
	},
}

local function UpdateUnitSettings()
	RUF.db.profile.unit.boss1 = RUF.db.profile.unit.boss
	RUF.db.profile.unit.boss2 = RUF.db.profile.unit.boss
	RUF.db.profile.unit.boss3 = RUF.db.profile.unit.boss
	RUF.db.profile.unit.boss4 = RUF.db.profile.unit.boss

	RUF.db.profile.unit.arena1 = RUF.db.profile.unit.arena
	RUF.db.profile.unit.arena2 = RUF.db.profile.unit.arena
	RUF.db.profile.unit.arena3 = RUF.db.profile.unit.arena
	RUF.db.profile.unit.arena4 = RUF.db.profile.unit.arena
	RUF.db.profile.unit.arena5 = RUF.db.profile.unit.arena

	RUF.db.profile.unit.party1 = RUF.db.profile.unit.party
	RUF.db.profile.unit.party2 = RUF.db.profile.unit.party
	RUF.db.profile.unit.party3 = RUF.db.profile.unit.party
	RUF.db.profile.unit.party4 = RUF.db.profile.unit.party

	ZZ = {
		[1] = {
			name = "player",
			group = "",
			frame = oUF_RUF_Player,
			order = 1,
		},
		[2] = {
			name = "pet",
			group = "",
			frame = oUF_RUF_Pet,
			order = 2,
		},
		[3] = {
			name = "target",
			group = "",
			frame = oUF_RUF_Target,
			order = 3,
		},
		[4] = {
			name = "targettarget",
			group = "",
			frame = oUF_RUF_TargetTarget,
			order = 4,
		},
		[5] = {
			name = "focus",
			group = "",
			frame = oUF_RUF_Focus,
			order = 5,
		},
	--	[0] = {
	--		name = "focustarget",
	--		group = "",
	--		frame = oUF_RUF_FocusTarget,
	--		order = 0,
	--	},
		[6] = {
			name = "boss1",
			group = "boss",
			frame = oUF_RUF_Boss1,
		},
		[7] = {
			name = "boss2",
			group = "boss",
			frame = oUF_RUF_Boss2,
		},
		[8] = {
			name = "boss3",
			group = "boss",
			frame = oUF_RUF_Boss3,
		},
		[9] = {
			name = "boss4",
			group = "boss",
			frame = oUF_RUF_Boss4,
		},
		[10] = {
			name = "arena1",
			group = "arena",
			frame = oUF_RUF_Arena1,
		},
		[11] = {
			name = "arena2",
			group = "arena",
			frame = oUF_RUF_Arena2,
		},
		[12] = {
			name = "arena3",
			group = "arena",
			frame = oUF_RUF_Arena3,
		},
		[13] = {
			name = "arena4",
			group = "arena",
			frame = oUF_RUF_Arena4,
		},
		[14] = {
			name = "arena5",
			group = "arena",
			frame = oUF_RUF_Arena5,
		},
		[15] = {
			name = "party1",
			group = "party",
			frame = oUF_RUF_PartyUnitButton1,
		},
		[16] = {
			name = "party2",
			group = "party",
			frame = oUF_RUF_PartyUnitButton2,
		},
		[17] = {
			name = "party3",
			group = "party",
			frame = oUF_RUF_PartyUnitButton3,
		},
		[18] = {
			name = "party4",
			group = "party",
			frame = oUF_RUF_PartyUnitButton4,
		},
	}


end


local _, PlayerClass = UnitClass('player')
local ClassPowerID, ClassPowerType, ClassPowerCharges, RequireSpec, RequireSpell, ClassVisibility
do -- Register Class Bar Variable Values
	if(PlayerClass == 'MONK') then
		ClassPowerID = 12
		ClassPowerType = "CHI"
		RequireSpec = SPEC_MONK_WINDWALKER
	elseif(PlayerClass == 'PALADIN') then
		ClassPowerID = 9
		ClassPowerType = "HOLY_POWER"
		RequireSpec = SPEC_PALADIN_RETRIBUTION
	elseif(PlayerClass == 'WARLOCK') then
		ClassPowerID = 7
		ClassPowerType = "SOUL_SHARDS"
	elseif(PlayerClass == 'ROGUE' or PlayerClass == 'DRUID') then
		ClassPowerID = 4
		ClassPowerType = 'COMBO_POINTS'
		if(PlayerClass == 'DRUID') then
			RequireSpell = 5221 -- Shred
		end
	elseif(PlayerClass == 'MAGE') then
		ClassPowerID = 16
		ClassPowerType = 'ARCANE_CHARGES'
		RequireSpec = SPEC_MAGE_ARCANE
	elseif(PlayerClass == 'DEATHKNIGHT') then
		ClassPowerID = 5
		ClassPowerType = 'RUNES'
	end
end

local function UpdateFrames()
	
	UpdateUnitSettings()
	for i = 1,#ZZ do
		if not ZZ[i].frame then return end -- If Party units aren't spawned, skip them.
		if ZZ[i].name == "arena1" or ZZ[i].name == "boss1" then
			ZZ[i].frame:ClearAllPoints()
			ZZ[i].frame:SetPoint(
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.AnchorPoint,
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.Anchor,
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.AnchorTo,
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.x,
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.y)
		end
		if ZZ[i].name == "party1" then
			oUF_RUF_Party:ClearAllPoints()
			oUF_RUF_Party:SetPoint(
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.AnchorPoint,
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.Anchor,
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.AnchorTo,
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.x,
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.y)
		end
		if ZZ[i].group == "" then
			ZZ[i].frame:ClearAllPoints()
			ZZ[i].frame:SetPoint(
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.AnchorPoint,
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.Anchor,
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.AnchorTo,
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.x,
				RUF.db.profile.unit[ZZ[i].name].Position.Frame.y)
		end

		ZZ[i].frame.Health:SetStatusBarTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.Health))
		ZZ[i].frame.Absorb:SetStatusBarTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.Absorb))
		ZZ[i].frame.Power:SetStatusBarTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.Power))

		ZZ[i].frame:SetWidth(RUF.db.profile.unit[ZZ[i].name].Width)
		ZZ[i].frame:SetHeight(RUF.db.profile.unit[ZZ[i].name].Height)

		ZZ[i].frame.Health:SetHeight(RUF.db.profile.unit[ZZ[i].name].Height -2)
		if ZZ[i].frame.Power:IsShown() then
			ZZ[i].frame.Health.bg:SetHeight((RUF.db.profile.unit[ZZ[i].name].Height - RUF.db.profile.unit[ZZ[i].name].PowerHeight) - 2)
		else
			ZZ[i].frame.Health.bg:SetHeight(RUF.db.profile.unit[ZZ[i].name].Height - 2)
		end
		-- IF BAR IS IN OVERLAY MODE.
		ZZ[i].frame.Absorb:SetHeight(RUF.db.profile.unit[ZZ[i].name].Height -2)

		-- ADD CHECK FOR IF POWER BAR IS SHOWN, AND PROPER ANCHOR POINT WHEN WE ADD CUSTOM POWER BAR LOCATIONS LATER
		if ZZ[i].frame.Power:IsShown() then
			ZZ[i].frame.Health.bg:SetPoint("BOTTOM",0,RUF.db.profile.unit[ZZ[i].name].PowerHeight)
		end
		ZZ[i].frame.Power:SetHeight(RUF.db.profile.unit[ZZ[i].name].PowerHeight)

		ZZ[i].frame.Health:ForceUpdate()
		ZZ[i].frame.Health:ForceUpdate()
		ZZ[i].frame.Power:ForceUpdate()
		ZZ[i].frame.Power:ForceUpdate()
		if ZZ[i].frame.AdditionalPower then
			ZZ[i].frame.AdditionalPower:ForceUpdate()
			ZZ[i].frame.AdditionalPower:ForceUpdate()
		end


		for index = 1,#Texts do
			if not _G[ZZ[i].frame:GetName() .. "." .. Texts[index].frame .. "Parent" .. "." .. Texts[index].frame] then return end
			

			-- TODO: Get Size and Outline from Profile.
			local _,size,outline = _G[ZZ[i].frame:GetName() .. "." .. Texts[index].frame .. "Parent" .. "." .. Texts[index].frame]:GetFont()			
			size = RUF.db.profile.unit[ZZ[i].name].Font[Texts[index].name].Size
			_G[ZZ[i].frame:GetName() .. "." .. Texts[index].frame .. "Parent" .. "." .. Texts[index].frame]:SetFont((LSM:Fetch("font", RUF.db.profile.Font[Texts[index].name].Type)), size, outline)
		end


		ZZ[i].frame.NameTextParent.NameText:UpdateTag()
		ZZ[i].frame.NameTextParent.NameText:ClearAllPoints()
		ZZ[i].frame.NameTextParent.NameText:SetPoint(
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Name.AnchorPoint,
			ZZ[i].frame,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Name.AnchorPoint,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Name.x,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Name.y)
		ZZ[i].frame.HealthTextParent.HealthText:UpdateTag()
		ZZ[i].frame.HealthTextParent.HealthText:ClearAllPoints()
		ZZ[i].frame.HealthTextParent.HealthText:SetPoint(
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Health.AnchorPoint,
			ZZ[i].frame,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Health.AnchorPoint,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Health.x,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Health.y)

		ZZ[i].frame.PowerTextParent.PowerText:UpdateTag()
		ZZ[i].frame.PowerTextParent.PowerText:ClearAllPoints()
		ZZ[i].frame.PowerTextParent.PowerText:SetPoint(
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Power.AnchorPoint,
			ZZ[i].frame,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Power.AnchorPoint,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Power.x,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Power.y)

		ZZ[i].frame.AdditionalPowerTextParent.AdditionalPowerText:UpdateTag()
		ZZ[i].frame.AdditionalPowerTextParent.AdditionalPowerText:ClearAllPoints()
		ZZ[i].frame.AdditionalPowerTextParent.AdditionalPowerText:SetPoint(
			RUF.db.profile.unit[ZZ[i].name].Position.Text.AdditionalPower.AnchorPoint,
			ZZ[i].frame,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.AdditionalPower.AnchorPoint,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.AdditionalPower.x,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.AdditionalPower.y)

		ZZ[i].frame.LevelTextParent.LevelText:UpdateTag()
		ZZ[i].frame.LevelTextParent.LevelText:ClearAllPoints()
		ZZ[i].frame.LevelTextParent.LevelText:SetPoint(
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Level.AnchorPoint,
			ZZ[i].frame,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Level.AnchorPoint,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Level.x,
			RUF.db.profile.unit[ZZ[i].name].Position.Text.Level.y)
	
		if RUF.db.profile.unit[ZZ[i].name].Texts.Name then
			ZZ[i].frame.NameTextParent:Show()
		else
			ZZ[i].frame.NameTextParent:Hide()
		end

		if RUF.db.profile.unit[ZZ[i].name].Texts.Health then
			ZZ[i].frame.HealthTextParent:Show()
		else
			ZZ[i].frame.HealthTextParent:Hide()
		end

		if RUF.db.profile.unit[ZZ[i].name].Texts.Power == 2 then
			ZZ[i].frame.PowerTextParent:Show()
		elseif RUF.db.profile.unit[ZZ[i].name].Texts.Power == 1 and UnitPower(ZZ[i].name) > 0 then
			ZZ[i].frame.PowerTextParent:Show()
		else
			ZZ[i].frame.PowerTextParent:Hide()
		end

		if RUF.db.profile.unit[ZZ[i].name].Texts.Level then
			ZZ[i].frame.LevelTextParent:Show()
		else
			ZZ[i].frame.LevelTextParent:Hide()
		end

	end
end

local ClassBar = {
	[1] = {
		Bar = oUF_RUF_Player_Class1,
		Background = oUF_RUF_Player_Class1BG,
		Parent = oUF_RUF_Player_Class1Parent,
	},
	[2] = {
		Bar = oUF_RUF_Player_Class2,
		Background = oUF_RUF_Player_Class2BG,
		Parent = oUF_RUF_Player_Class2Parent,
	},
	[3] = {
		Bar = oUF_RUF_Player_Class3,
		Background = oUF_RUF_Player_Class3BG,
		Parent = oUF_RUF_Player_Class3Parent,
	},
	[4] = {
		Bar = oUF_RUF_Player_Class4,
		Background = oUF_RUF_Player_Class4BG,
		Parent = oUF_RUF_Player_Class4Parent,
	},
	[5] = {
		Bar = oUF_RUF_Player_Class5,
		Background = oUF_RUF_Player_Class5BG,
		Parent = oUF_RUF_Player_Class5Parent,
	},
	[6] = {
		Bar = oUF_RUF_Player_Class6,
		Background = oUF_RUF_Player_Class6BG,
		Parent = oUF_RUF_Player_Class6Parent,
	},

}
local function UpdateClassBar()	
	-- if spec / spell isn't true, hide, if it is, show.
	if (ClassPowerID) then -- If we're a class that should show a class bar
		local UnitPowerMaxAmount = UnitPowerMax("player", ClassPowerID)
		if(not RequireSpec or RequireSpec == GetSpecialization()) then -- If the class requires a specific spec, and if so, if we are that spec.
			if(not RequireSpell or IsPlayerSpell(RequireSpell)) then -- If the class requires a specific spell, druid cat form.
				local pr,pg,pb = unpack(RUF.db.profile.Colors.PowerColors[ClassPowerID])

				local UnitPowerMaxAmount = UnitPowerMax("player", ClassPowerID)
				local multiplier
				local constant = 10
				local size = (RUF.db.profile.unit["player"].Width + (UnitPowerMaxAmount - 1))  / UnitPowerMaxAmount -- Scale size to fit with 1 Pixel Border
				oUF_RUF_Player.Health.bg:SetPoint("TOP",0, - (RUF.db.profile.unit["player"].ClassBarHeight -1))




				if PlayerClass == "DEATHKNIGHT" then
					local spec = GetSpecialization()
					if spec == 1 then --Blood
						pr,pg,pb = unpack(RUF.db.profile.Colors.PowerColors[50])
						constant = 10
					elseif spec == 2 then -- Frost
						pr,pg,pb = unpack(RUF.db.profile.Colors.PowerColors[51])
						constant = 10
					elseif spec == 3 then -- Unholy
						pr,pg,pb = unpack(RUF.db.profile.Colors.PowerColors[52])
						constant = 10
					else -- WTF
						pr,pg,pb = unpack(RUF.db.profile.Colors.PowerColors[ClassPowerID]
					)
					end
				end
				
				for index = 1, UnitPowerMaxAmount do
					multiplier = index
					if UnitPowerMaxAmount == 4 then
						multiplier = index +1
					end
					ClassBar[index].Bar:SetHeight(RUF.db.profile.unit["player"].ClassBarHeight-2)
					ClassBar[index].Parent:SetWidth(size)
					ClassBar[index].Parent:SetHeight(RUF.db.profile.unit["player"].ClassBarHeight)
					ClassBar[index].Parent:SetPoint('TOPLEFT', oUF_RUF_Player, 'TOPLEFT', ((index - 1) * size - ((index - 1 ) * 1)), 0) -- Scale size to fit with 1 Pixel Border
					ClassBar[index].Background:SetColorTexture(pr*0.35,pg*0.35,pb*0.35,0.75)
					local curr = (pr*((((multiplier+constant)*6.6667)/100)))
					local curg = (pg*((((multiplier+constant)*6.6667)/100)))
					local curb = (pb*((((multiplier+constant)*6.6667)/100)))
					ClassBar[index].Bar:SetStatusBarTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.Class))
					--ClassBar[index].Background:SetTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.Class))					
					ClassBar[index].Bar:SetStatusBarColor(curr,curg,curb)
				end
			end
		end
	end
end



local Options = {
	type = "group",
	name = function(info)
		return "RUF [|c5500DBBDRaeli's Unit Frames|r]" .. (GetAddOnMetadata("RUF", "Version") or "") .. " " .. (GetAddOnMetadata("RUF", "X-Curse-Packaged-Version") or "") .. "|r"
	end,	
	order = 0,
	childGroups = "tab",
	args = {
		GlobalOptions = {
			name = L["Global Options"],
			desc = L["These settings affect all frames."],
			type = "group",
			order = 0,
			args = {
				Health = {
					type = "header",
					name = L["Health Bar Settings"],
					order = 0,
				},
				HealthTexture = {
					type = "select",
					name = L["Health Texture"],
					desc = L["Set the Health bar texture."],
					width = "normal",
					values = LSM:HashTable("statusbar"),
					dialogControl = "LSM30_Statusbar",
					order = 0.1,
					get = function(info)
						return RUF.db.profile.Texture.Health
					end,
					set = function(info, value)
						RUF.db.profile.Texture.Health = value
						UpdateFrames()
					end,
				},
				AbsorbTexture = {
					type = "select",
					name = L["Absorb Texture"],
					desc = L["Set the Absorb bar texture."],
					width = "normal",
					values = LSM:HashTable("statusbar"),
					dialogControl = "LSM30_Statusbar",
					order = 0.11,
					get = function(info)
						return RUF.db.profile.Texture.Absorb
					end,
					set = function(info, value)
						RUF.db.profile.Texture.Absorb = value
						UpdateFrames()
					end,
				},
				Health_Spacer_0 = {
					type = "description",
					name = "  ",
					width = "full",
					order = 0.12,
				},	
				HealthColor = {
					order = 0.2,
					type = "color",
					name = L["Health Color"],
					desc = L["Base color. Other options take precedent."],
					get = function(info)
						return RUF.db.profile.Colors.Health.HealthColor[1],RUF.db.profile.Colors.Health.HealthColor[2],RUF.db.profile.Colors.Health.HealthColor[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.Health.HealthColor = {r,g,b}
						UpdateFrames()
					end,
				},
				AbsorbColor = {
					order = 0.3,
					type = "color",
					hasAlpha = true,
					name = L["Absorb Color"],
					desc = L["Absorb Bar Color, including opacity"],
					get = function(info)
						return RUF.db.profile.Colors.MiscColors.Absorb[1],RUF.db.profile.Colors.MiscColors.Absorb[2],RUF.db.profile.Colors.MiscColors.Absorb[3],RUF.db.profile.Colors.MiscColors.Absorb[4]
					end,
					set = function(info,r,g,b,a)
						RUF.db.profile.Colors.MiscColors.Absorb = {r,g,b,a}
						UpdateFrames()
					end,
				},
				Health_Spacer_1 = {
					type = "description",
					name = "  ",
					width = "full",
					order = 0.99,
				},	
				TappingColor = {
					order = 1.0,
					type = "color",
					name = L["Tapped Color"],
					get = function(info)
						return RUF.db.profile.Colors.MiscColors.Tapping[1],RUF.db.profile.Colors.MiscColors.Tapping[2],RUF.db.profile.Colors.MiscColors.Tapping[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.MiscColors.Tapping = {r,g,b}
						UpdateFrames()
					end,
				},
				Health_TappingEnabled = {
					order = 1.01,
					type = "toggle",
					width = "double",
					name = L["Color if unit is tapped"],
					get = function(info)
						return RUF.db.profile.Colors.Health.colorTapping
					end,
					set = function(info, value)
						RUF.db.profile.Colors.Health.colorTapping = value
						UpdateFrames()
					end,
				},
				DisconnectedColor = {
					order = 1.1,
					type = "color",
					name = L["Disconnected Color"],
					get = function(info)
						return RUF.db.profile.Colors.MiscColors.Disconnected[1],RUF.db.profile.Colors.MiscColors.Disconnected[2],RUF.db.profile.Colors.MiscColors.Disconnected[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.MiscColors.Disconnected = {r,g,b}
						UpdateFrames()
					end,
				},
				DisconnectedEnabled = {
					order = 1.11,
					type = "toggle",
					width = "double",
					name = L["Color if unit is disconnected"],
					get = function(info)
						return RUF.db.profile.Colors.Health.colorDisconnected
					end,
					set = function(info, value)
						RUF.db.profile.Colors.Health.colorDisconnected = value
						UpdateFrames()
					end,
				},
				Health_Spacer_2 = {
					type = "description",
					name = "  ",
					width = "full",
					order = 1.5,
				},				   
				Health_ClassColor = {-- Priority: Tapping, Disconnected, Class, ClassNPC, ClassPet, Reaction, Smooth, Health
					order = 2.0,
					type = "toggle",
					name = L["Color by class"],
					get = function(info)
						return RUF.db.profile.Colors.Health.colorClass
					end,
					set = function(info, value)
						RUF.db.profile.Colors.Health.colorClass = value
						UpdateFrames()
					end,
				},
				Health_ReactionColor = {
					order = 2.1,
					type = "toggle",
					name = L["Color by reaction"],
					get = function(info)
						return RUF.db.profile.Colors.Health.colorReaction
					end,
					set = function(info, value)
						RUF.db.profile.Colors.Health.colorReaction = value
						UpdateFrames()
					end,
				},
				Health_PercentageColor = {
					order = 2.2,
					type = "toggle",
					name = L["Color by percentage"],
					get = function(info)
						return RUF.db.profile.Colors.Health.colorSmooth
					end,
					set = function(info, value)
						RUF.db.profile.Colors.Health.colorSmooth = value
						UpdateFrames()
					end,
				},
				Health_PercentageColor_100 = {
					order = 3.0,
					type = "color",
					name = L["Full"],
					desc = L["Color at 100%"],
					hidden =  function() return not RUF.db.profile.Colors.Health.colorSmooth end,
					get = function(info)
						return RUF.db.profile.Colors.Health.BarGradient[7],RUF.db.profile.Colors.Health.BarGradient[8],RUF.db.profile.Colors.Health.BarGradient[9]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.Health.BarGradient[7] = r
						RUF.db.profile.Colors.Health.BarGradient[8] = g
						RUF.db.profile.Colors.Health.BarGradient[9] = b
						UpdateFrames()
					end,
				},
				Health_PercentageColor_50 = {
					order = 3.1,
					type = "color",
					name = L["Half"],
					desc = L["Color at 50%"],
					hidden =  function() return not RUF.db.profile.Colors.Health.colorSmooth end,
					get = function(info)
						return RUF.db.profile.Colors.Health.BarGradient[4],RUF.db.profile.Colors.Health.BarGradient[5],RUF.db.profile.Colors.Health.BarGradient[6]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.Health.BarGradient[4] = r
						RUF.db.profile.Colors.Health.BarGradient[5] = g
						RUF.db.profile.Colors.Health.BarGradient[6] = b
						UpdateFrames()
					end,
				},
				Health_PercentageColor_0 = {
					order = 3.2,
					type = "color",
					name = L["Zero"],
					desc = L["Color at 0%"],
					hidden =  function() return not RUF.db.profile.Colors.Health.colorSmooth end,
					get = function(info)
						return RUF.db.profile.Colors.Health.BarGradient[1],RUF.db.profile.Colors.Health.BarGradient[2],RUF.db.profile.Colors.Health.BarGradient[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.Health.BarGradient[1] = r
						RUF.db.profile.Colors.Health.BarGradient[2] = g
						RUF.db.profile.Colors.Health.BarGradient[3] = b
						UpdateFrames()
					end,
				},


				Power = {
					type = "header",
					name = L["Power Bar Settings"],
					order = 10,
				},
				PowerTexture = {
					type = "select",
					name = L["Power Texture"],
					desc = L["Set the Power bar texture."],
					values = LSM:HashTable("statusbar"),
					dialogControl = "LSM30_Statusbar",
					order = 10.1,
					get = function(info)
						return RUF.db.profile.Texture.Power
					end,
					set = function(info, value)
						RUF.db.profile.Texture.Power = value
						UpdateFrames()
					end,
				},
				AdditionalPowerTexture = {
					type = "select",
					name = L["Additional Power Texture"],
					desc = L["Set the Additional Power bar texture."],
					values = LSM:HashTable("statusbar"),
					dialogControl = "LSM30_Statusbar",
					order = 10.1,
					get = function(info)
						return RUF.db.profile.Texture.AdditionalPower
					end,
					set = function(info, value)
						RUF.db.profile.Texture.AdditionalPower = value
						UpdateFrames()
					end,
				},

				--[[Power_Spacer_1 = {
					type = "description",
					name = "  ",
					width = "half",
					order = 10.2,
				},]]--	
				ClassPowerTexture = {
					type = "select",
					name = L["Class Power Bar Texture"],
					desc = L["Set the Class power bar texture."],
					values = LSM:HashTable("statusbar"),
					dialogControl = "LSM30_Statusbar",
					order = 10.3,
					get = function(info)
						return RUF.db.profile.Texture.Class
					end,
					set = function(info, value)
						RUF.db.profile.Texture.Class = value
						local UnitPowerMaxAmount = UnitPowerMax("player", ClassPowerID)
						oUF_RUF_Player_Class1:SetStatusBarTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.Class))
						oUF_RUF_Player_Class2:SetStatusBarTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.Class))
						oUF_RUF_Player_Class3:SetStatusBarTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.Class))
						oUF_RUF_Player_Class4:SetStatusBarTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.Class))
						if UnitPowerMaxAmount >= 5 then
							oUF_RUF_Player_Class5:SetStatusBarTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.Class))
						end
						if UnitPowerMaxAmount >= 6 then
							oUF_RUF_Player_Class6:SetStatusBarTexture(LSM:Fetch("statusbar", RUF.db.profile.Texture.Class))
						end						
					end,
				},
				Power_Spacer_2 = {
					type = "description",
					name = "  ",
					width = "full",
					order = 10.5,
				},
				Power_PowerColor = {
					order = 10.60,
					type = "toggle",
					name = L["Color by power type"],
					get = function(info)
						return RUF.db.profile.Colors.Power.colorPower
					end,
					set = function(info, value)
						RUF.db.profile.Colors.Power.colorPower = value
						UpdateFrames()
					end,
				},
				Power_TappingEnabled = {
					order = 10.61,
					type = "toggle",
					name = L["Color if unit is tapped"],
					get = function(info)
						return RUF.db.profile.Colors.Power.colorTapping
					end,
					set = function(info, value)
						RUF.db.profile.Colors.Power.colorTapping = value
						UpdateFrames()
					end,
				},
				Power_DisconnectedEnabled = {
					order = 10.62,
					type = "toggle",
					name = L["Color if unit is disconnected"],
					get = function(info)
						return RUF.db.profile.Colors.Power.colorDisconnected
					end,
					set = function(info, value)
						RUF.db.profile.Colors.Power.colorDisconnected = value
						UpdateFrames()
					end,
				},
				Power_ClassColor = {-- Priority: Tapping, Disconnected, Class, ClassNPC, ClassPet, Reaction, Smooth, Health
					order = 10.7,
					type = "toggle",
					name = L["Color by class"],
					get = function(info)
						return RUF.db.profile.Colors.Power.colorClass
					end,
					set = function(info, value)
						RUF.db.profile.Colors.Power.colorClass = value
						UpdateFrames()
					end,
				},
				Power_ReactionColor = {
					order = 10.71,
					type = "toggle",
					name = L["Color by reaction"],
					get = function(info)
						return RUF.db.profile.Colors.Power.colorReaction
					end,
					set = function(info, value)
						RUF.db.profile.Colors.Power.colorReaction = value
						UpdateFrames()
					end,
				},
				Power_PercentageColor = {
					order = 10.72,
					type = "toggle",
					name = L["Color by percentage"],
					get = function(info)
						return RUF.db.profile.Colors.Power.colorSmooth
					end,
					set = function(info, value)
						RUF.db.profile.Colors.Power.colorSmooth = value
						UpdateFrames()
					end,
				},
				Power_Spacer_3 = {
					type = "description",
					name = "  ",
					width = "full",
					order = 10.73,
					hidden =  function() return not RUF.db.profile.Colors.Power.colorSmooth end,
				},
				Power_PercentageColor_100 = {
					order = 10.74,
					type = "color",
					name = L["Full"],
					desc = L["Color at 100%"],
					hidden =  function() return not RUF.db.profile.Colors.Power.colorSmooth end,
					get = function(info)
						return RUF.db.profile.Colors.Power.BarGradient[7],RUF.db.profile.Colors.Power.BarGradient[8],RUF.db.profile.Colors.Power.BarGradient[9]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.Power.BarGradient[7] = r
						RUF.db.profile.Colors.Power.BarGradient[8] = g
						RUF.db.profile.Colors.Power.BarGradient[9] = b
						UpdateFrames()
					end,
				},
				Power_PercentageColor_50 = {
					order = 10.74,
					type = "color",
					name = L["Half"],
					desc = L["Color at 50%"],
					hidden =  function() return not RUF.db.profile.Colors.Power.colorSmooth end,
					get = function(info)
						return RUF.db.profile.Colors.Power.BarGradient[4],RUF.db.profile.Colors.Power.BarGradient[5],RUF.db.profile.Colors.Power.BarGradient[6]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.Power.BarGradient[4] = r
						RUF.db.profile.Colors.Power.BarGradient[5] = g
						RUF.db.profile.Colors.Power.BarGradient[6] = b
						UpdateFrames()
					end,
				},
				Power_PercentageColor_0 = {
					order = 10.75,
					type = "color",
					name = L["Zero"],
					desc = L["Color at 0%"],
					hidden =  function() return not RUF.db.profile.Colors.Power.colorSmooth end,
					get = function(info)
						return RUF.db.profile.Colors.Power.BarGradient[1],RUF.db.profile.Colors.Power.BarGradient[2],RUF.db.profile.Colors.Power.BarGradient[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.Power.BarGradient[1] = r
						RUF.db.profile.Colors.Power.BarGradient[2] = g
						RUF.db.profile.Colors.Power.BarGradient[3] = b
						UpdateFrames()
					end,
				},
				Power_Spacer_4 = {
					type = "description",
					name = "  ",
					width = "full",
					order = 10.76,
				},

				PowerBaseColor = {
					order = 11.0,
					type = "color",
					name = L["Power Color"],
					desc = L["Base color. Other options take precedent."],
					get = function(info)
						return unpack(RUF.db.profile.Colors.Power.PowerColor)
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.Power.PowerColor = {r,g,b}
						UpdateFrames()
					end,
				},
				Colors_Power_Mana = {
					order = 11.2,
					type = "color",
					name = _G['MANA'] or MANA,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[0][1],RUF.db.profile.Colors.PowerColors[0][2],RUF.db.profile.Colors.PowerColors[0][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[0] = {r,g,b}
						UpdateFrames()
					end,
				},
				Colors_Power_Rage = {
					order = 11.2,
					type = "color",
					name = _G['RAGE'] or RAGE,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[1][1],RUF.db.profile.Colors.PowerColors[1][2],RUF.db.profile.Colors.PowerColors[1][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[1] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Focus = {
					order = 11.2,
					type = "color",
					name = _G['FOCUS'] or FOCUS,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[2][1],RUF.db.profile.Colors.PowerColors[2][2],RUF.db.profile.Colors.PowerColors[2][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[2] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Energy = {
					order = 11.2,
					type = "color",
					name = _G['ENERGY'] or ENERGY,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[3][1],RUF.db.profile.Colors.PowerColors[3][2],RUF.db.profile.Colors.PowerColors[3][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[3] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Combo = {
					order = 11.2,
					type = "color",
					name = _G['COMBO_POINTS'] or COMBO_POINTS,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[4][1],RUF.db.profile.Colors.PowerColors[4][2],RUF.db.profile.Colors.PowerColors[4][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[4] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Runes = {
					order = 11.2,
					type = "color",
					name = _G['RUNES'] or RUNES,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[5][1],RUF.db.profile.Colors.PowerColors[5][2],RUF.db.profile.Colors.PowerColors[5][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[5] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_RunesBlood = {
					order = 11.2,
					type = "color",
					name = L["Runes - Blood"],
					get = function(info)
						return unpack(RUF.db.profile.Colors.PowerColors[50])
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[50] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_RunesFrost = {
					order = 11.2,
					type = "color",
					name = L["Runes - Frost"],
					get = function(info)
						return unpack(RUF.db.profile.Colors.PowerColors[51])
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[51] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_RunesUnholy = {
					order = 11.2,
					type = "color",
					name = L["Runes - Unholy"],
					get = function(info)
						return unpack(RUF.db.profile.Colors.PowerColors[52])
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[52] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Runic = {
					order = 11.2,
					type = "color",
					name = _G['RUNIC_POWER'] or RUNIC_POWER,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[6][1],RUF.db.profile.Colors.PowerColors[6][2],RUF.db.profile.Colors.PowerColors[6][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[6] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Shards = {
					order = 11.2,
					type = "color",
					name = _G['SOUL_SHARDS'] or SOUL_SHARDS,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[7][1],RUF.db.profile.Colors.PowerColors[7][2],RUF.db.profile.Colors.PowerColors[7][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[7] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Astral = {
					order = 11.2,
					type = "color",
					name = _G['LUNAR_POWER'] or LUNAR_POWER,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[8][1],RUF.db.profile.Colors.PowerColors[8][2],RUF.db.profile.Colors.PowerColors[8][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[8] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Holy = {
					order = 11.2,
					type = "color",
					name = _G['HOLY_POWER'] or HOLY_POWER,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[9][1],RUF.db.profile.Colors.PowerColors[9][2],RUF.db.profile.Colors.PowerColors[9][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[9] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Maelstrom = {
					order = 11.2,
					type = "color",
					name = _G['MAELSTROM'] or MAELSTROM,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[11][1],RUF.db.profile.Colors.PowerColors[11][2],RUF.db.profile.Colors.PowerColors[11][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[11] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Chi = {
					order = 11.2,
					type = "color",
					name = _G['CHI'] or CHI,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[12][1],RUF.db.profile.Colors.PowerColors[12][2],RUF.db.profile.Colors.PowerColors[12][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[12] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Insanity = {
					order = 11.2,
					type = "color",
					name = _G['INSANITY'] or INSANITY,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[13][1],RUF.db.profile.Colors.PowerColors[13][2],RUF.db.profile.Colors.PowerColors[13][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[13] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Arcane = {
					order = 11.2,
					type = "color",
					name = _G['ARCANE_CHARGES'] or ARCANE_CHARGES,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[16][1],RUF.db.profile.Colors.PowerColors[16][2],RUF.db.profile.Colors.PowerColors[16][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[16] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Fury = {
					order = 11.2,
					type = "color",
					name = _G['FURY'] or FURY,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[17][1],RUF.db.profile.Colors.PowerColors[17][2],RUF.db.profile.Colors.PowerColors[17][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[17] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},
				Colors_Power_Pain = {
					order = 11.2,
					type = "color",
					name = _G['PAIN'] or PAIN,
					get = function(info)
						return RUF.db.profile.Colors.PowerColors[18][1],RUF.db.profile.Colors.PowerColors[18][2],RUF.db.profile.Colors.PowerColors[18][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.PowerColors[18] = {r,g,b}
						UpdateFrames()
						UpdateClassBar()
					end,
				},

				ClassColors = {
					type = "header",
					name = L["Class Colors"],
					order = 20,
				},
				ClassColors_UseAddon = {
					order = 20.01,
					type = "toggle",
					name = L["Use colors from the Class Colors addon"],
					width = "full",
					get = function(info)
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then
							for classToken, color in next, CUSTOM_CLASS_COLORS do
								RUF.db.profile.Colors.ClassColors[classToken] = {(color.r), (color.g), (color.b)}				
							end
						end
						return RUF.db.profile.Colors.MiscColors.UseClassColors
					end,
					set = function(info, value)
						RUF.db.profile.Colors.MiscColors.UseClassColors = value
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then
							for classToken, color in next, CUSTOM_CLASS_COLORS do
								RUF.db.profile.Colors.ClassColors[classToken] = {(color.r), (color.g), (color.b)}				
							end
						end
						UpdateFrames()
					end,
				},
				ClassColors_DeathKnight = {
					order = 21.0,
					type = "color",
					name = select(1,(GetClassInfo(6))),
					disabled = function() 
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then							
							return true
						end
					end, -- !ClassColors takes precedent.
					get = function(info)
						return RUF.db.profile.Colors.ClassColors.DEATHKNIGHT[1],RUF.db.profile.Colors.ClassColors.DEATHKNIGHT[2],RUF.db.profile.Colors.ClassColors.DEATHKNIGHT[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ClassColors.DEATHKNIGHT = {r,g,b}
						UpdateFrames()
					end,
				},
				ClassColors_DemonHunter = {
					order = 21.1,
					type = "color",
					name = select(1,(GetClassInfo(12))),
					disabled = function() 
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then							
							return true
						end
					end, -- !ClassColors takes precedent.
					get = function(info)
						return RUF.db.profile.Colors.ClassColors.DEMONHUNTER[1],RUF.db.profile.Colors.ClassColors.DEMONHUNTER[2],RUF.db.profile.Colors.ClassColors.DEMONHUNTER[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ClassColors.DEMONHUNTER = {r,g,b}
						UpdateFrames()
					end,
				},
				ClassColors_Druid = {
					order = 21.2,
					type = "color",
					name = select(1,(GetClassInfo(11))),
					disabled = function() 
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then							
							return true
						end
					end, -- !ClassColors takes precedent.
					get = function(info)
						return RUF.db.profile.Colors.ClassColors.DRUID[1],RUF.db.profile.Colors.ClassColors.DRUID[2],RUF.db.profile.Colors.ClassColors.DRUID[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ClassColors.DRUID = {r,g,b}
						UpdateFrames()
					end,
				},
				ClassColors_Hunter = {
					order = 21.3,
					type = "color",
					name = select(1,(GetClassInfo(3))),
					disabled = function() 
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then							
							return true
						end
					end, -- !ClassColors takes precedent.
					get = function(info)
						return RUF.db.profile.Colors.ClassColors.HUNTER[1],RUF.db.profile.Colors.ClassColors.HUNTER[2],RUF.db.profile.Colors.ClassColors.HUNTER[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ClassColors.HUNTER = {r,g,b}
						UpdateFrames()
					end,
				},
				ClassColors_Mage = {
					order = 21.4,
					type = "color",
					name = select(1,(GetClassInfo(8))),
					disabled = function() 
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then							
							return true
						end
					end, -- !ClassColors takes precedent.
					get = function(info)
						return RUF.db.profile.Colors.ClassColors.MAGE[1],RUF.db.profile.Colors.ClassColors.MAGE[2],RUF.db.profile.Colors.ClassColors.MAGE[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ClassColors.MAGE = {r,g,b}
						UpdateFrames()
					end,
				},
				ClassColors_Monk = {
					order = 21.5,
					type = "color",
					name = select(1,(GetClassInfo(10))),
					disabled = function() 
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then							
							return true
						end
					end, -- !ClassColors takes precedent.
					get = function(info)
						return RUF.db.profile.Colors.ClassColors.MONK[1],RUF.db.profile.Colors.ClassColors.MONK[2],RUF.db.profile.Colors.ClassColors.MONK[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ClassColors.MONK = {r,g,b}
						UpdateFrames()
					end,
				},
				ClassColors_Paladin = {
					order = 21.6,
					type = "color",
					name = select(1,(GetClassInfo(2))),
					disabled = function() 
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then							
							return true
						end
					end, -- !ClassColors takes precedent.
					get = function(info)
						return RUF.db.profile.Colors.ClassColors.PALADIN[1],RUF.db.profile.Colors.ClassColors.PALADIN[2],RUF.db.profile.Colors.ClassColors.PALADIN[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ClassColors.PALADIN = {r,g,b}
						UpdateFrames()
					end,
				},
				ClassColors_Priest = {
					order = 21.7,
					type = "color",
					name = select(1,(GetClassInfo(5))),
					disabled = function() 
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then							
							return true
						end
					end, -- !ClassColors takes precedent.
					get = function(info)
						return RUF.db.profile.Colors.ClassColors.PRIEST[1],RUF.db.profile.Colors.ClassColors.PRIEST[2],RUF.db.profile.Colors.ClassColors.PRIEST[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ClassColors.PRIEST = {r,g,b}
						UpdateFrames()
					end,
				},
				ClassColors_Rogue = {
					order = 21.8,
					type = "color",
					name = select(1,(GetClassInfo(4))),
					disabled = function() 
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then							
							return true
						end
					end, -- !ClassColors takes precedent.
					get = function(info)
						return RUF.db.profile.Colors.ClassColors.ROGUE[1],RUF.db.profile.Colors.ClassColors.ROGUE[2],RUF.db.profile.Colors.ClassColors.ROGUE[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ClassColors.ROGUE = {r,g,b}
						UpdateFrames()
					end,
				},
				ClassColors_Shaman = {
					order = 21.9,
					type = "color",
					name = select(1,(GetClassInfo(7))),
					disabled = function() 
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then							
							return true
						end
					end, -- !ClassColors takes precedent.
					get = function(info)
						return RUF.db.profile.Colors.ClassColors.SHAMAN[1],RUF.db.profile.Colors.ClassColors.SHAMAN[2],RUF.db.profile.Colors.ClassColors.SHAMAN[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ClassColors.SHAMAN = {r,g,b}
						UpdateFrames()
					end,
				},
				ClassColors_Warlock = {
					order = 21.10,
					type = "color",
					name = select(1,(GetClassInfo(9))),
					disabled = function() 
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then							
							return true
						end
					end, -- !ClassColors takes precedent.
					get = function(info)
						return RUF.db.profile.Colors.ClassColors.WARLOCK[1],RUF.db.profile.Colors.ClassColors.WARLOCK[2],RUF.db.profile.Colors.ClassColors.WARLOCK[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ClassColors.WARLOCK = {r,g,b}
						UpdateFrames()
					end,
				},
				ClassColors_Warrior = {
					order = 21.11,
					type = "color",
					name = select(1,(GetClassInfo(1))),
					disabled = function() 
						if(CUSTOM_CLASS_COLORS) and RUF.db.profile.Colors.MiscColors.UseClassColors then							
							return true
						end
					end, -- !ClassColors takes precedent.
					get = function(info)
						return RUF.db.profile.Colors.ClassColors.WARRIOR[1],RUF.db.profile.Colors.ClassColors.WARRIOR[2],RUF.db.profile.Colors.ClassColors.WARRIOR[3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ClassColors.WARRIOR = {r,g,b}
						UpdateFrames()
					end,
				},

				ReactionColors = {
					type = "header",
					name = L["Reaction Colors"],
					order = 30,
				},
				ReactionColors_1 = {
					order = 31.1,
					type = "color",
					name = FACTION_STANDING_LABEL1,
					get = function(info)
						return RUF.db.profile.Colors.ReactionColors[1][1],RUF.db.profile.Colors.ReactionColors[1][2],RUF.db.profile.Colors.ReactionColors[1][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ReactionColors[1] = {r,g,b}
						UpdateFrames()
					end,
				},
				ReactionColors_2 = {
					order = 31.2,
					type = "color",
					name = FACTION_STANDING_LABEL2,
					get = function(info)
						return RUF.db.profile.Colors.ReactionColors[2][1],RUF.db.profile.Colors.ReactionColors[2][2],RUF.db.profile.Colors.ReactionColors[2][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ReactionColors[2] = {r,g,b}
						UpdateFrames()
					end,
				},
				ReactionColors_3 = {
					order = 31.3,
					type = "color",
					name = FACTION_STANDING_LABEL3,
					get = function(info)
						return RUF.db.profile.Colors.ReactionColors[3][1],RUF.db.profile.Colors.ReactionColors[3][2],RUF.db.profile.Colors.ReactionColors[3][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ReactionColors[3] = {r,g,b}
						UpdateFrames()
					end,
				},
				ReactionColors_4 = {
					order = 31.4,
					type = "color",
					name = FACTION_STANDING_LABEL1,
					get = function(info)
						return RUF.db.profile.Colors.ReactionColors[4][1],RUF.db.profile.Colors.ReactionColors[4][2],RUF.db.profile.Colors.ReactionColors[4][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ReactionColors[4] = {r,g,b}
						UpdateFrames()
					end,
				},
				ReactionColors_5 = {
					order = 31.5,
					type = "color",
					name = FACTION_STANDING_LABEL5,
					get = function(info)
						return RUF.db.profile.Colors.ReactionColors[5][1],RUF.db.profile.Colors.ReactionColors[5][2],RUF.db.profile.Colors.ReactionColors[5][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ReactionColors[5] = {r,g,b}
						UpdateFrames()
					end,
				},
				ReactionColors_6 = {
					order = 31.6,
					type = "color",
					name = FACTION_STANDING_LABEL6,
					get = function(info)
						return RUF.db.profile.Colors.ReactionColors[6][1],RUF.db.profile.Colors.ReactionColors[6][2],RUF.db.profile.Colors.ReactionColors[6][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ReactionColors[6] = {r,g,b}
						UpdateFrames()
					end,
				},
				ReactionColors_7 = {
					order = 31.7,
					type = "color",
					name = FACTION_STANDING_LABEL7,
					get = function(info)
						return RUF.db.profile.Colors.ReactionColors[7][1],RUF.db.profile.Colors.ReactionColors[7][2],RUF.db.profile.Colors.ReactionColors[7][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ReactionColors[7] = {r,g,b}
						UpdateFrames()
					end,
				},
				ReactionColors_8 = {
					order = 31.8,
					type = "color",
					name = FACTION_STANDING_LABEL8,
					get = function(info)
						return RUF.db.profile.Colors.ReactionColors[8][1],RUF.db.profile.Colors.ReactionColors[8][2],RUF.db.profile.Colors.ReactionColors[8][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ReactionColors[8] = {r,g,b}
						UpdateFrames()
					end,
				},
				ReactionColors_9 = {
					order = 31.9,
					type = "color",
					name = L["Paragon"],
					hidden = true, -- Hidden until I figure out how to track this properly.
					get = function(info)
						return RUF.db.profile.Colors.ReactionColors[9][1],RUF.db.profile.Colors.ReactionColors[9][2],RUF.db.profile.Colors.ReactionColors[9][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ReactionColors[9] = {r,g,b}
						UpdateFrames()
					end,
				},
				ReactionColors_10 = {
					order = 31.91,
					type = "color",
					name = L["Friendly Pet"],
					get = function(info)
						return RUF.db.profile.Colors.ReactionColors[10][1],RUF.db.profile.Colors.ReactionColors[10][2],RUF.db.profile.Colors.ReactionColors[10][3]
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Colors.ReactionColors[10] = {r,g,b}
						UpdateFrames()
					end,
				},
			},
		},-- GlobalOptions
	}, -- Options Args
}

local function TextOptionSetup()
	local TextOptions = {
		name = L["Text Options"],
		desc = L["Settings for text elements."],
		type = "group",
		childGroups = "select",
		order = 2,
		args = {
			Header_Nickname = {
				type = "header",
				name = L["Nickname Settings"],
				order = 0,
			},
			NickName = {
				type = "input",
				name = L["Nickname"],
				desc = L["You can set a nickname to replace your character's name on all RUF frames. Leave blank for your character's name."],
				width = "full",
				order = 0.1,
				multiline = false,
				get = function(info)
					return RUF.db.char.unit["player"].NickName
				end,
				set = function(info, value)
					RUF.db.char.unit["player"].NickName = value
					UpdateFrames()
				end,
			},
		},
	}
	for index = 1,#Texts do		
		TextOptions.args[Texts[index].name] = {
			type = "group",
			name = L[Texts[index].name .. " Text"],
			order = 20,
			args = {
				Font = {
					type = "select",
					name = L["Font"],
					desc = L["Set the font used on all unit frames."],
					order = 20.01,
					values = LSM:HashTable("font"),
					dialogControl = "LSM30_Font",
					get = function(info)
						return RUF.db.profile.Font[Texts[index].name].Type
					end,
					set = function(info, value)
						RUF.db.profile.Font[Texts[index].name].Type = value
						UpdateFrames()																				  			
					end,
				},
				Case = {
					type = "select",
					name = L["Text Case"],
					desc = L["Choose if text is Capitalised, All Lower Case or all Upper case."],
					order = 20.01,
					values = {
						[0] = L["Normal"],
						[1] = L["Upper Case"],
						[2] = L["Lower Case"],
					},
					get = function(info)
						return RUF.db.profile.Font[Texts[index].name].Case
					end,
					set = function(info, value)
						RUF.db.profile.Font[Texts[index].name].Case = value
						UpdateFrames()																				  			
					end,
				},
				Spacer_A = {
					type = "description",
					name = " ",
					fontSize = "large",
					order = 20.02,
				},
				Gradient = {--GradientAtMax, Gradient, Class, Reaction, Base
					order = 20.03,
					type = "toggle",
					width = "double",
					name = L["Color by percentage"],
					get = function(info)
						return RUF.db.profile.Font[Texts[index].name].colorGradient
					end,
					set = function(info, value)
						RUF.db.profile.Font[Texts[index].name].colorGradient = value
						UpdateFrames()
					end,
				},
				GradientAtMax = {
					order = 20.04,
					type = "toggle",
					width = "double",
					name = L["Color by percentage at max"],
					get = function(info)
						return RUF.db.profile.Font[Texts[index].name].colorGradientAtMax
					end,
					set = function(info, value)
						RUF.db.profile.Font[Texts[index].name].colorGradientAtMax = value
						UpdateFrames()
					end,
				},
				ClassColor = {-- Priority: Tapping, Disconnected, Class, ClassNPC, ClassPet, Reaction, Smooth, Health
					order = 20.05,
					type = "toggle",
					width = "double",
					name = L["Color player by class"],
					get = function(info)
						return RUF.db.profile.Font[Texts[index].name].colorClass
					end,
					set = function(info, value)
						RUF.db.profile.Font[Texts[index].name].colorClass = value
						UpdateFrames()
					end,
				},
				ReactionColor = {
					order = 20.06,
					type = "toggle",
					width = "double",
					name = L["Color by reaction"],
					get = function(info)
						return RUF.db.profile.Font[Texts[index].name].colorReaction
					end,
					set = function(info, value)
						RUF.db.profile.Font[Texts[index].name].colorReaction = value
						UpdateFrames()
					end,
				},
				PrimaryPowerColor = {
					order = 20.07,
					type = "toggle",
					width = "double",
					name = L["Color by power type"],
					get = function(info)
						return RUF.db.profile.Font[Texts[index].name].colorPower
					end,
					set = function(info, value)
						RUF.db.profile.Font[Texts[index].name].colorPower = value
						UpdateFrames()
					end,
				},
				Color = {
					order = 20.99,
					type = "color",
					width = "double",
					name = L["Base Text Color"],
					disabled = function() return RUF.db.profile.Font[Texts[index].name].colorClass == true end,
					get = function(info)
						return unpack(RUF.db.profile.Font[Texts[index].name].Color)
					end,
					set = function(info,r,g,b)
						RUF.db.profile.Font[Texts[index].name].Color = {r,g,b}
						UpdateFrames()
					end,
				},
			},
		}
	end
	return TextOptions
end



local function UnitOptionSetup()
	local UnitOptions = {
		name = L["Unit Options"],
		desc = L["Settings for individual units."],
		type = "group",
		childGroups = "select",
		order = 1,
		args = {
			player = {

			},
		},
	}
	local bossdone
	local arenadone
	local partydone

	local function UnitArgs(name, index)
		UnitOptions.args[name] = {
			type = "group",
			name = L[name],
			order = index,
			childGroups = "tab",
			args = {
				Category_Header_FrameSizing = {
					type = "group",
					name = L["Frame Settings"],
					order = 10,
					args = {
						Width = {
							type = "range",
							name = L["Frame Width"],
							desc = L["Width of the Unitframe."],
							order = 10.1,
							min = 50,
							max = 750,
							softMin = 100,
							softMax = 400,
							step = 1,
							bigStep = 10,
							get = function(info)
								return RUF.db.profile.unit[name].Width
							end,
							set = function(info, value)
								RUF.db.profile.unit[name].Width = value
								UpdateFrames()
								UpdateClassBar()
							end,
						},
						HealthHeight = {
							type = "range",
							name = L["Health Height"],
							desc = L["Height of the Health bar."],
							order = 10.2,
							min = 10,
							max = 300,
							softMin = 20,
							softMax = 100,
							step = 1,
							bigStep = 5,
							get = function(info)
								return RUF.db.profile.unit[name].Height
							end,
							set = function(info, value)
								RUF.db.profile.unit[name].Height = value
								UpdateFrames()
								UpdateClassBar()
							end,
						},
						PowerHeight = {
							type = "range",
							name = L["Power Height"],
							desc = L["Height of the Power bar."],
							order = 10.3,
							min = 2,
							max = 100,
							softMin = 5,
							softMax = 50,
							step = 1,
							bigStep = 1,
							get = function(info)
								return RUF.db.profile.unit[name].PowerHeight
							end,
							set = function(info, value)
								RUF.db.profile.unit[name].PowerHeight = value
								UpdateFrames()
								UpdateClassBar()
							end,
						},
						ClassPowerHeight = {
							type = "range",
							name = L["Class Power Height"],
							desc = L["Height of the Class Power bar."],
							hidden = function()	return name ~= "player" end,
							order = 10.4,
							min = 2,
							max = 100,
							softMin = 5,
							softMax = 50,
							step = 1,
							bigStep = 1,
							get = function(info)
								return RUF.db.profile.unit[name].ClassBarHeight
							end,
							set = function(info, value)
								RUF.db.profile.unit[name].ClassBarHeight = value
								UpdateClassBar()
							end,
						},
						PowerBarDisplayType = {
							type = "select",
							name = L["Show Power"],
							order = 10.5,
							values = {
								[0] = L["Always Hidden"],
								[1] = L["Hidden at 0"],
								[2] = L["Always Visible"],
							},
							get = function(info)
								return RUF.db.profile.unit[name].Bars.Power
							end,
							set = function(info, value)
								RUF.db.profile.unit[name].Bars.Power = value
								UpdateFrames()
							end,
						},
						AdditionalPowerBarDisplayType = {
							type = "select",
							name = L["Show Additional Power"],
							hidden = function()	return name ~= "player" end,
							order = 10.6,
							values = {
								[0] = L["Always Hidden"],
								[1] = L["Hidden at 0"],
								[2] = L["Always Visible"],
							},
							get = function(info)
								return RUF.db.profile.unit[name].Bars.AdditionalPower
							end,
							set = function(info, value)
								RUF.db.profile.unit[name].Bars.AdditionalPower = value
								UpdateFrames()
							end,
						},
						Category_Header_FramePosition = {
							type = "header",
							name = L["Frame Position Settings"],
							order = 20,
						},
						Frame_X = {
							type = "range",
							name = L["X Offset"],
							desc = L["Horizontal Offset from the Frame Anchor."],
							order = 20.1,
							min = -5000,
							max = 5000,
							softMin = -1000,
							softMax = 1000,
							step = 0.5,
							bigStep = 1,
							get = function(info)
								return RUF.db.profile.unit[name].Position.Frame.x
							end,
							set = function(info, value)
								RUF.db.profile.unit[name].Position.Frame.x = value
								UpdateFrames()
							end,
						},
						Frame_Y = {
							type = "range",
							name = L["Y Offset"],
							desc = L["Vertical Offset from the Frame Anchor."],
							order = 20.1,
							min = -5000,
							max = 5000,
							softMin = -1000,
							softMax = 1000,
							step = 0.5,
							bigStep = 1,
							get = function(info)
								return RUF.db.profile.unit[name].Position.Frame.y
							end,
							set = function(info, value)
								RUF.db.profile.unit[name].Position.Frame.y = value
								UpdateFrames()
							end,
						},
						Frame_Anchor_Point = {
							type = "select",
							name = L["Anchor Point"],
							desc = L["Anchor Point on the unit frame."],
							--width = "full",
							order = 20.4,
							values = {
								TOP = L["Top"],
								RIGHT = L["Right"],
								BOTTOM = L["Bottom"],
								LEFT = L["Left"],
								TOPRIGHT = L["Top-right"],
								TOPLEFT = L["Top-left"],
								BOTTOMRIGHT = L["Bottom-right"],
								BOTTOMLEFT = L["Bottom-left"],
								CENTER = L["Center"],
							},
							get = function(info)
								return RUF.db.profile.unit[name].Position.Frame.AnchorPoint						
							end,
							set = function(info, value)
								RUF.db.profile.unit[name].Position.Frame.AnchorPoint = value
								UpdateFrames()
							end,
						},
						Frame_Anchor_To = {
							type = "select",
							name = L["Relative Point"],
							desc = L["Point on the anchor frame to anchor to."],
							--width = "full",
							order = 20.4,
							values = {
								TOP = L["Top"],
								RIGHT = L["Right"],
								BOTTOM = L["Bottom"],
								LEFT = L["Left"],
								TOPRIGHT = L["Top-right"],
								TOPLEFT = L["Top-left"],
								BOTTOMRIGHT = L["Bottom-right"],
								BOTTOMLEFT = L["Bottom-left"],
								CENTER = L["Center"],
							},
							get = function(info)
								return RUF.db.profile.unit[name].Position.Frame.AnchorTo					
							end,
							set = function(info, value)
								RUF.db.profile.unit[name].Position.Frame.AnchorTo = value
								UpdateFrames()
							end,
						},
						Frame_Anchor = {
							type = "input",
							name = L["Anchor Frame"],
							desc = L["Set the name of the frame for the unit to anchor to. Defaults to UI Parent if set blank."],
							--width = "full",
							multiline = false,
							order = 21.6,
							get = function(info)
								return RUF.db.profile.unit[name].Position.Frame.Anchor
							end,
							set = function(info, value)
								if ZZ[index].frame:GetName() == value then return end -- If we're trying to set the anchor to ourselves.
								if value ~= nil and value:match("%S") ~= nil then -- If the value isn't empty. If it is, set to UIParent.
									if _G[value] then -- If the frame exists, if it doesn't, set to UIParent.
										local point,anchor,relative,x,y = _G[value]:GetPoint()
										if anchor ~= nil then
											if anchor:GetName() ~= ZZ[index].frame:GetName() then -- Check that it's not anchored to the frame we're currently editing.
												RUF.db.profile.unit[name].Position.Frame.Anchor = value
											end
										else
											RUF.db.profile.unit[name].Position.Frame.Anchor = value
										end
									else
										RUF.db.profile.unit[name].Position.Frame.Anchor = "UIParent"
									end
								else
									RUF.db.profile.unit[name].Position.Frame.Anchor = "UIParent"
								end
								UpdateFrames()
							end,
						},
					},
				},
			},
		}
		for i = 1,#Texts do
			UnitOptions.args[name].args[Texts[i].name] = {
				type = "group",
				name = L[Texts[i].name .. " Text"],
				order = 40,
				args = {
					Enabled = {
						type = "toggle",
						name = L["Enable " .. Texts[i].name .. " Text"],
						desc = "",
						order = 0.01,
						get = function(info)
							return RUF.db.profile.unit[name].Texts[Texts[i].name]
						end,
						set = function(info, value)
							RUF.db.profile.unit[name].Texts[Texts[i].name] = value
							UpdateFrames()
						end,
					},
					Tag = {
						type = "input",
						name = L[Texts[i].name .. " Tag"],
						desc = "",
						width = "double",
						multiline = false,
						order = 0.02,
						get = function(info)
							return RUF.db.profile.unit[name].Tags[Texts[i].name]								
						end,
						set = function(info, value)
							RUF.db.profile.unit[name].Tags[Texts[i].name] = value
							UpdateFrames()
						end,
					},
					X = {
						type = "range",
						name = L["X Offset"],
						desc = L["Horizontal Offset from the Frame Anchor."],
						order = 0.03,
						min = floor(- RUF.db.profile.unit[name].Width * 1.5),
						max = floor(RUF.db.profile.unit[name].Width * 1.5),
						softMin = floor(- RUF.db.profile.unit[name].Width * 1.5),
						softMax = floor(RUF.db.profile.unit[name].Width * 1.5),
						step = 0.5,
						bigStep = 1,
						get = function(info)
							return RUF.db.profile.unit[name].Position.Text[Texts[i].name].x
						end,
						set = function(info, value)
							RUF.db.profile.unit[name].Position.Text[Texts[i].name].x = value
							UpdateFrames()
						end,
					},
					Y = {
						type = "range",
						name = L["Y Offset"],
						desc = L["Vertical Offset from the Frame Anchor."],
						order = 0.04,
						min = floor(- RUF.db.profile.unit[name].Height * 1.5),
						max = floor(RUF.db.profile.unit[name].Height * 1.5),
						softMin = floor(- RUF.db.profile.unit[name].Height * 1.5),
						softMax = floor(RUF.db.profile.unit[name].Height * 1.5),
						step = 0.5,
						bigStep = 1,
						get = function(info)
							return RUF.db.profile.unit[name].Position.Text[Texts[i].name].y
						end,
						set = function(info, value)
							RUF.db.profile.unit[name].Position.Text[Texts[i].name].y = value
							UpdateFrames()
						end,
					},
					AnchorPoint = {
						type = "select",
						name = L["Anchor Point"],
						desc = L["Anchor Point on the unit frame."],
						--width = "full",
						order = 0.05,
						values = {
							TOP = L["Top"],
							RIGHT = L["Right"],
							BOTTOM = L["Bottom"],
							LEFT = L["Left"],
							TOPRIGHT = L["Top-right"],
							TOPLEFT = L["Top-left"],
							BOTTOMRIGHT = L["Bottom-right"],
							BOTTOMLEFT = L["Bottom-left"],
							CENTER = L["Center"],
						},
						get = function(info)
							return RUF.db.profile.unit[name].Position.Text[Texts[i].name].AnchorPoint						
						end,
						set = function(info, value)
							RUF.db.profile.unit[name].Position.Text[Texts[i].name].AnchorPoint = value
							UpdateFrames()
						end,
					},
					FontSize = {
						type = "range",
						name = L["Font Size"],
						order = 0.06,
						min = 4,
						max = 256,
						softMin = 8,
						softMax = 48,
						step = 1,
						bigStep = 1,
						get = function(info)
							return RUF.db.profile.unit[name].Font[Texts[i].name].Size

							
						end,
						set = function(info, value)
							RUF.db.profile.unit[name].Font[Texts[i].name].Size = value
							UpdateFrames()
						end,
					},
				},
			}
		end
		UnitOptions.args[name].args["Power"].args.Enabled = {
			type = "select",
			name = L["Enable Power Text"],
			desc = "",
			order = 0.01,
			values = {
				[0] = L["Always Hidden"],
				[1] = L["Hidden at 0"],
				[2] = L["Always Visible"],
			},
			get = function(info)
				return RUF.db.profile.unit[name].Texts.Power
				
			end,
			set = function(info, value)
				RUF.db.profile.unit[name].Texts.Power = value
				UpdateFrames()
			end,
		}
	end

	for index = 1,#ZZ do
		if ZZ[index].group == "boss" and bossdone ~= true then
			bossdone = true
			UnitArgs(ZZ[index].group, 51)
		elseif ZZ[index].group == "arena" and arenadone ~= true then
			arenadone = true
			UnitArgs(ZZ[index].group, 50)
		elseif ZZ[index].group == "party" and partydone ~= true then
			partydone = true
			UnitArgs(ZZ[index].group, 52)
		elseif ZZ[index].group == "" then -- SINGLE UNIT OPTIONS
			UnitArgs(ZZ[index].name, ZZ[index].order)
		end
	end

	return UnitOptions
end



-----------------------
---- Ace functions ----
-----------------------
function RUF_O:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("RUFDB", DefaultOptions) -- Setup Saved Variables
	UpdateUnitSettings()


	
	
	-- Profile Management --
	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
	------------------------
	db = self.db.profile

	-- Register Various Options
	LibStub("AceConfig-3.0"):RegisterOptionsTable("RUF", Options) -- Register Options
	local Profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db) -- Add profile management to Blizzard interface
	Options.args.profiles = Profiles
	Options.args.UnitOptions = UnitOptionSetup()
	Options.args.TextOptions = TextOptionSetup()
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("RUF", "RUF") -- Add options to Blizzard interface
	
	-- Add dual-spec support
	local LibDualSpec = LibStub('LibDualSpec-1.0')
	LibDualSpec:EnhanceDatabase(self.db, "RUF")
	LibDualSpec:EnhanceOptions(Profiles, self.db)
	
	InterfaceAddOnsList_Update()
end
function RUF_O:RefreshConfig(event, database, newProfileKey)
	RUF.db = database -- Setup Saved Variables
	ReloadUI()
end
